/**
* @file      GoogleMap.js
* @brief     This Scene is the Google Map Service.
* @author    Moataz Abdallh
* @date      27 june 2013
*/

alert('SceneGoogleMap.js loaded');

function SceneGoogleMap() {
	this.index=null; // Location Index.
	this.map=null; // Google Map Object
	this.zoom=8;
	this.lat=null;
	this.lng=null;
	this.mapOptions=null;
	this.arrayPosition=null;
	this.enTitle=null;
	this.arTitle=null;
	this.point=null;
	this.windowFlag=true;
}

SceneGoogleMap.prototype.initialize = function () {
	alert("SceneGoogleMap.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
	


								  
}

SceneGoogleMap.prototype.handleShow = function (data) {
	alert("SceneGoogleMap.handleShow()");
	// this function will be called when the scene manager show this scene 
	var scenemaps = sf.scene.get('Maps');
	
	switch(scenemaps.index){
	case 1:
		var scenenillevalley=sf.scene.get('NileValley');
		this.index=scenenillevalley.HighlightIndex;
		this.lat=scenenillevalley.LocationsArray[this.index].lat;
		this.lng=scenenillevalley.LocationsArray[this.index].lng;
		this.arTitle=scenenillevalley.LocationsArray[this.index].ar;
		this.enTitle=scenenillevalley.LocationsArray[this.index].en;
		break;
		
	case 2:
		var scenemediterranean=sf.scene.get('Mediterranean');
		this.index=scenemediterranean.HighlightIndex;
		this.lat=scenemediterranean.LocationsArray[this.index].lat;
		this.lng=scenemediterranean.LocationsArray[this.index].lng;
		this.arTitle=scenemediterranean.LocationsArray[this.index].ar;
		this.enTitle=scenemediterranean.LocationsArray[this.index].en;
		break;
		
	case 3:
		var scenewesterndesert=sf.scene.get('WesternDesert');
		this.index=scenewesterndesert.HighlightIndex;
		this.lat=scenewesterndesert.LocationsArray[this.index].lat;
		this.lng=scenewesterndesert.LocationsArray[this.index].lng;
		this.arTitle=scenewesterndesert.LocationsArray[this.index].ar;
		this.enTitle=scenewesterndesert.LocationsArray[this.index].en;
		break;
		
	case 4:
		var sceneredsea=sf.scene.get('RedSea');
		this.index=sceneredsea.HighlightIndex;
		this.lat=sceneredsea.LocationsArray[this.index].lat;
		this.lng=sceneredsea.LocationsArray[this.index].lng;
		this.arTitle=sceneredsea.LocationsArray[this.index].ar;
		this.enTitle=sceneredsea.LocationsArray[this.index].en;
		break;
	}
		
	if(EnglishFlag){
		$('#GoogleMapKeyHelp').sfKeyHelp({
			'blue':'عربى',
			'yellow':'Close Info Window',
			'red':'Zoom In',
			'green':'Zoom Out',
			'move':'Navigation',
			'return':'Return'
		});
	}
	else{
		$('#GoogleMapKeyHelp').sfKeyHelp({
			'blue':'English',
			'yellow':'إغلاق نافذة المعلومات',
			'red':'تكبير',
			'green':'تصغير',
			'move':'تحريك',
			'return':'رجوع'
		});
	}
	//Creating Map class Instance.

	
	 	this.map = new GMap2(document.getElementById("map-canvas"));
	 	this.map.setCenter(new GLatLng(this.lat,this.lng), this.zoom);
	 	this.point = new GLatLng(this.lat,this.lng);
	 	var marker = new GMarker(this.point);
	    this.map.addOverlay(marker);
	    var mapControl=new GLargeMapControl3D();
	    this.map.addControl(mapControl);
	    if(EnglishFlag){
	    	this.map.openInfoWindowHtml(this.point,"<h4>Info Window</h4><p>"+this.enTitle+"</p>");
	    }
	    else{
	    	this.map.openInfoWindowHtml(this.point,"<h4 class='Arabic'>نافذة المعلومات</h4><p class='Arabic'>"+this.arTitle+"</p>");
	    }
	    
	    if(!AdFlag){
	    if (deviceapis.recognition.IsRecognitionSupported()) {
			deviceapis.recognition.SubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "GoogleMap", handleGoogleMapRecognitionEvent);
			//deviceapis.recognition.SetVoiceTimeout(40000);
		} 
		else {
			alert("ERROR: Voice recognition not supported");
		}
		
		var googlemapHelpbar = {
				helpbarType: "HELPBAR_TYPE_VOICE_CUSTOMIZE",
				bKeepCurrentInfo: "false",
				helpbarItemsList: [
					{ itemText: "Left", commandList: [{command: "Left"}]},
					{ itemText: "Right", commandList: [{command: "Right"}]},
					{ itemText: "Up", commandList: [{command: "Up"}]},
					{ itemText: "Down", commandList: [{command: "Down"}]},
					{ itemText: "Zoom In", commandList: [{command: "Zoom In"}]},
					{ itemText: "Zoom Out", commandList: [{command: "Zoom Out"}]},
					{ itemText: "Return", commandList: [{command: "Return"}]}
					]
		};
		deviceapis.recognition.SetVoiceHelpbarInfo(JSON.stringify(googlemapHelpbar));
  }
}
//Handling Voice commands
handleGoogleMapRecognitionEvent= function (evt) {
	var _THIS_=sf.scene.get('GoogleMap');
	switch (evt.eventtype) {
		case "EVENT_VOICE_BEGIN_MONITOR":
		case "EVENT_VOICE_BTSOUND_START":
			break;
		case "EVENT_VOICE_RECOG_RESULT":
			switch (evt.result.toLowerCase()) {
			case "left": _THIS_.map.panDirection(1, 0); break;
			case "right": _THIS_.map.panDirection(-1, 0); break;
			case "up": _THIS_.map.panDirection(0, 1); break;
			case "down": _THIS_.map.panDirection(0, -1); break;
			case "zoom in": _THIS_.zoom++;
						 _THIS_.map.setZoom(_THIS_.zoom); break;
			case "zoom out": _THIS_.zoom--;
			 _THIS_.map.setZoom(_THIS_.zoom); break;
			case "return": _THIS_.returnNavigation(); break;
		}
			break;
	}
}
//END Voice handling
SceneGoogleMap.prototype.handleHide = function () {
	alert("SceneGoogleMap.handleHide()");
	// this function will be called when the scene manager hide this scene  
}

SceneGoogleMap.prototype.handleFocus = function () {
	alert("SceneGoogleMap.handleFocus()");
	// this function will be called when the scene manager focus this scene
}


SceneGoogleMap.prototype.handleBlur = function () {
	alert("SceneGoogleMap.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneGoogleMap.prototype.updateKeyHelp = function () {
	alert("SceneGoogleMap.updateKeyHelp()");
	// this function update keyhelp & Info Window
	if(EnglishFlag){ 
		if(this.windowFlag){
			this.map.openInfoWindowHtml(this.point,"<h4 class='English'>Info Window</h4><p class='English'>"+this.enTitle+"</p>");
			$('#GoogleMapKeyHelp').sfKeyHelp({
				'blue':'عربى',
				'yellow':'Close Info Window',
				'red':'Zoom In',
				'green':'Zoom Out',
				'move':'Navigation',
				'return':'Return'
			});
			
		}
		else{
			this.map.closeInfoWindow();
			$('#GoogleMapKeyHelp').sfKeyHelp({
				'blue':'عربى',
				'yellow':'Open Info Window',
				'red':'Zoom In',
				'green':'Zoom Out',
				'move':'Navigation',
				'return':'Return'
			});
		}
	}
	else{
		if(this.windowFlag){
			this.map.openInfoWindowHtml(this.point,"<h4 class='Arabic'>نافذة المعلومات</h4><p class='Arabic'>"+this.arTitle+"</p>");
			$('#GoogleMapKeyHelp').sfKeyHelp({
				'blue':'English',
				'yellow':'إغلاق نافذة المعلومات',
				'red':'تكبير',
				'green':'تصغير',
				'move':'تحريك',
				'return':'رجوع'
				});	
		}
		else{
			this.map.closeInfoWindow();
			$('#GoogleMapKeyHelp').sfKeyHelp({
				'blue':'English',
				'yellow':'فتح نافذة المعلومات',
				'red':'تكبير',
				'green':'تصغير',
				'move':'تحريك',
				'return':'رجوع'
				});	
		}
	}
}

SceneGoogleMap.prototype.returnNavigation = function(){
	//This function handle return remote controller event & return voice command. 
	if(!AdFlag){
	if (deviceapis.recognition) {//unsubscribe Event handlers
		deviceapis.recognition.UnsubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "GoogleMap");
	}
	}
	this.zoom=8;
	sf.scene.hide('GoogleMap');
	sf.scene.show('Location');
	sf.scene.focus('Location');
	sf.key.preventDefault();
}
SceneGoogleMap.prototype.handleKeyDown = function (keyCode) {
	alert("SceneGoogleMap.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	switch (keyCode) {
		case sf.key.LEFT:
			alert("LEFT:"+sf.key.LEFT);
			this.map.panDirection(1, 0);
			break;
		case sf.key.RIGHT:
			this.map.panDirection(-1, 0);
			break;
		case sf.key.UP:
			this.map.panDirection(0, 1);
			break;
		case sf.key.DOWN:
			this.map.panDirection(0, -1);
			break;
		case sf.key.ENTER:
			break;
		case sf.key.BLUE:
			alert("BLUE:"+sf.key.BLUE);
			EnglishFlag=!EnglishFlag;
			this.updateKeyHelp();
			break;
		case sf.key.RED:
			alert("RED:"+sf.key.RED);
			this.zoom++;
			this.map.setZoom(this.zoom);
			break;
		case sf.key.GREEN:
			alert("GREEN:"+sf.key.GREEN);
			this.zoom--;
			this.map.setZoom(this.zoom);
			break;
		case sf.key.YELLOW:
			alert("YELLOW:"+sf.key.YELLOW);
			this.windowFlag=!this.windowFlag;
			this.updateKeyHelp();
			break;
		case sf.key.RETURN:
			alert("RETURN:"+sf.key.RETURN);
			this.returnNavigation();
			sf.key.preventDefault();
			break;
	}
}