/**
* @file      History.js
* @brief     This Scene display Egypt's History.
* @author    Moataz Abdallh
* @date      28 May  2013
*/

alert('SceneHistory.js loaded');

function SceneHistory() {
	this.pages = 0;
	this.scrollSize = 330;
	this.arrayHistory= null;
	this.enHistoryDescription=null;
	this.enHistoryDescription=null;
	this.arHistoryDescription=null;
	this.arHistoryDescription=null;
	this.enupPages=0;
	this.endownPages=0;
	this.arupPages=0;
	this.ardownPages=0;
	this.top=0;
	this.arabicLoaded=true;
	this.count=0; //used to solve scrolling issue as addListenerEvent called twice.
	this.adFocus=false;
	this.ar_page=[]; // used to convert number from english to arabic.
	this.firstTime=true; //used to avoiding loading icon if u enter the scene on 2nd time.
}

SceneHistory.prototype.initialize = function () {
	alert("SceneHistory.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
	//HISTORY XML
	this.arrayHistory = [];
    var _THIS_ = this;
	
    $.ajax({
        type: "get"
        ,dataType: "xml"
        ,url: "xml/History.xml"
        ,success: function(xml){
		
            if($(xml).find("item").length > 0){ // null check
			
                $(xml).find("item").each(function(){ // loop
                   
                    var h_ar_history = $(this).find("ar_history").text(); 
                    var h_en_history = $(this).find("en_history").text(); 

                    var hArticle = {};
                    hArticle.ar_history = h_ar_history;
                    hArticle.en_history= h_en_history;
            
                    _THIS_.arrayHistory.push(hArticle);					
                });      
                
            }
        }
        ,error: function(){ alert("xml error!!");  }
    });
    
    this.enHistoryDescription = document.getElementById('enHistoryDescription');
	this.enHistoryFrame = document.getElementById('enHistoryFrame');
	this.arHistoryDescription = document.getElementById('arHistoryDescription');
	this.arHistoryFrame = document.getElementById('arHistoryFrame');
	
	// AdHub XHR Object Literal
	$("#Ad_banner").sfAdHubView({
	order:"start",
	inventoryId:"xv0d00000001zu",
	size:"HHBANNER",
	focusColor:"#47C2E7",
	});
}


SceneHistory.prototype.handleShow = function (data) {
	alert("SceneHistory.handleShow()");
	// this function will be called when the scene manager show this scene 
	//AdHub
	$("#Ad_banner").sfAdHubView({
		order:"start"
	});
	
	if(EnglishFlag){
		$('#HistoryKeyHelp').sfKeyHelp({
			'blue':'عربى',
			'updown':'Scroll',
			'return':'Return'
		});
	}
	else{
		$('#HistoryKeyHelp').sfKeyHelp({
			'blue':'English',
			'updown':'تحريك',
			'return':'رجوع'
		});
	}
	
	//Wrapping History Content.
	if(this.firstTime){
		this.firstTime=false;
		$('#HistoryLoading').sfLoading('show'); //Showing Loading Icon  
	}
	var _THIS_ = this;
	 setTimeout(function(){
	    	$('#enHistoryDescription').html("<p>"+_THIS_.arrayHistory[0].en_history+"</p>").removeClass('Ar').addClass('En');
	    	$('#arHistoryDescription').html("<p>"+_THIS_.arrayHistory[0].ar_history+"</p>").removeClass('En').addClass('Ar');
	    	$('#enHistoryTitle').html ("<h1>Egypt's History</h1>").css('direction','ltr');
	    	$('#arHistoryTitle').html ("<h1>نبذه عن التاريخ المصرى</h1>").css('direction','rtl'); 
	    	if(EnglishFlag){
	    		$('#arHistoryTitle').css('display','none');
	        	$('#arHistoryDescription').css('display','none');
	        	$('#enHistoryTitle').css('display','block');  		
	    		$('#enHistoryDescription').css('display','block');
	        	
	    	}
	    	else{
	    		$('#enHistoryTitle').css('display','none');  		
	    		$('#enHistoryDescription').css('display','none');
	    		$('#arHistoryTitle').css('display','block');
	        	$('#arHistoryDescription').css('display','block');
	    	}
	    	_THIS_.adjustScrollBar();
	    	$('#TitleLine').css('display','block');
	    	$('#HistoryLoading').sfLoading('hide');},500);
	 
	 //Handling Scroll Event

	 window.addEventListener('DOMMouseScroll', wheelHistory, false);	 
	 window.onmousewheel = document.onmousewheel = wheelHistory;
	 
	 //Checking Voice support
	 if(!AdFlag){
	 if (deviceapis.recognition.IsRecognitionSupported()) {
			deviceapis.recognition.SubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "History", handleHistoryRecognitionEvent);
		} 
		else {
			alert("ERROR: Voice recognition not supported");
		}
	 var historyHelpbar = {
				helpbarType: "HELPBAR_TYPE_VOICE_CUSTOMIZE",
				bKeepCurrentInfo: "false",
				helpbarItemsList: [
					{ itemText: "Up", commandList: [{command: "Up"}]},
					{ itemText: "Down", commandList: [{command: "Down"}]},
					{ itemText: "Return", commandList: [{command: "Return"}]},
					]
		};
		deviceapis.recognition.SetVoiceHelpbarInfo(JSON.stringify(historyHelpbar));
}
}
function wheelHistory(e) {
	  e.preventDefault();
	  var _THIS_ = sf.scene.get('History');
	  _THIS_.count++; //This flag used as the wheelHistory is called twice when the event fires so we only excute the odd fires.
	  scrolling(e);
	 
}
//Scrolling Event Handler.
function scrolling(e){
	var _THIS_ = sf.scene.get('History');
	if(!(_THIS_.count&1)){
	 if(e.wheelDelta<0){ //this means scrolling down
		  if(EnglishFlag){
     		if(_THIS_.endownPages<_THIS_.pages-1) { 
     			_THIS_.endownPages++;
     			_THIS_.enupPages--;
     				$('#enHistoryDescription').addClass('position');
     				_THIS_.top=-_THIS_.scrollSize*(_THIS_.endownPages);
     				$('#enHistoryDescription').css("top",_THIS_.top );
     				$('#enHistoryScroll').sfScroll('next');
     				//Updating Current Page Number
     		     	$('#enCurrentPage').text(Math.abs(_THIS_.endownPages)+1);
     		}
     				
     	}
     	else{
     				if(_THIS_.ardownPages<_THIS_.pages-1) { 
     					_THIS_.ardownPages++;
     					_THIS_.arupPages--;
     					$('#arHistoryDescription').addClass('position');
     					_THIS_.top=-_THIS_.scrollSize*(_THIS_.ardownPages);
         				$('#arHistoryDescription').css("top",_THIS_.top );
         				$('#arHistoryScroll').sfScroll('next');
         				//Updating Current Page Number
         		     	$('#arCurrentPage').text(_THIS_.convertArabicNumber((Math.abs(_THIS_.ardownPages)+1).toString()));
     													}
     		}
	  			}
	  else{
		  if(EnglishFlag){
				 if(_THIS_.enupPages<0){
					 _THIS_.enupPages++;
					 _THIS_.endownPages--;
       	$('#enHistoryDescription').addClass('position');
       	_THIS_.top=_THIS_.scrollSize*(_THIS_.enupPages);
       	$('#enHistoryDescription').css("top", _THIS_.top);
       	$('#enHistoryScroll').sfScroll('prev');
       	//Updating Current Page Number
     	$('#enCurrentPage').text(Math.abs(_THIS_.enupPages)+1);
				 }
			 }
			 else{
				 if(_THIS_.arupPages<0){
					 _THIS_.arupPages++;
					 _THIS_.ardownPages--;
				 $('#arHistoryDescription').addClass('position');
				 _THIS_.top=_THIS_.scrollSize*(_THIS_.arupPages);
				 $('#arHistoryDescription').css("top",_THIS_.top);
				 $('#arHistoryScroll').sfScroll('prev');
				//Updating Current Page Number
  		     	$('#arCurrentPage').text(_THIS_.convertArabicNumber((Math.abs(_THIS_.arupPages)+1).toString()));
				 }
			 }
	  }}
}

//Handling Voice commands
handleHistoryRecognitionEvent= function (evt) {
	var _THIS_=sf.scene.get('History');
	switch (evt.eventtype) {
		case "EVENT_VOICE_BEGIN_MONITOR":
		case "EVENT_VOICE_BTSOUND_START":
			break;
		case "EVENT_VOICE_RECOG_RESULT":
			switch (evt.result.toLowerCase()) {
			case "up": _THIS_.upNavigation(); break;
			case "down": _THIS_.downNavigation(); break;
			case "return": _THIS_.returnNavigation(); break;
		}
			
			break;
	}
}
//END Voice handling
SceneHistory.prototype.handleHide = function () {
	alert("SceneHistory.handleHide()");
	// this function will be called when the scene manager hide this scene  
}

SceneHistory.prototype.handleFocus = function () {
	alert("SceneHistory.handleFocus()");
	// this function will be called when the scene manager focus this scene
}


SceneHistory.prototype.handleBlur = function () {
	alert("SceneHistory.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneHistory.prototype.adjustScrollBar = function () {
    alert("SceneHistory.adjustScrollBar()");
    var articleLength = null;
    var frameLength = null;
    if(EnglishFlag){
    		articleLength = this.enHistoryDescription.scrollHeight;
    		frameLength = this.enHistoryFrame.offsetHeight;
    }
    else{
    	articleLength = this.arHistoryDescription.scrollHeight;
		frameLength = this.arHistoryFrame.offsetHeight;
    }
    this.pages = Math.ceil(((articleLength - frameLength) / this.scrollSize) + 1);	
    alert("this.pages == "+this.pages+" articleLength == "+articleLength+" frameLength == "+frameLength);
    if(this.pages < 0) {
    	this.pages = 0;
    }
    
    if(this.pages <= 1) {
    	this.hideScrollBar();
    }
    else {
    	this.showScrollBar();
    }    	
    $('#enTotalPage').text(this.pages);
    $('#arTotalPage').text(this.convertArabicNumber(this.pages.toString()));
   
    
}

SceneHistory.prototype.showScrollBar = function () {
    alert("SceneHistory.showScrollBar()");
    
    $('#upArrow').css('display','block');
    $('#downArrow').css('display','block');
	
    if(EnglishFlag){
    	$('#arHistoryScroll').sfScroll('hide');
    	$('#enHistoryScroll').sfScroll({ pages:this.pages});
    	$('#enHistoryScroll').css('right','58px');
    	$('#upArrow').removeClass('left').addClass('right');
    	$('#downArrow').removeClass('left').addClass('right');
    	$('#enHistoryScroll').sfScroll('show');
    }
    else{
    	$('#enHistoryScroll').sfScroll('hide');
    	$('#arHistoryScroll').sfScroll({ pages:this.pages});
    	$('#arHistoryScroll').css('left','55px');
    	$('#upArrow').removeClass('right').addClass('left');
    	$('#downArrow').removeClass('right').addClass('left');
    	$('#arHistoryScroll').sfScroll('show');
    }
	
	}
SceneHistory.prototype.hideScrollBar = function () {
    alert("SceneHistory.hideScrollBar()");

    	 $('#enHistoryScroll').sfScroll('hide');

    	 $('#arHistoryScroll').sfScroll('hide');
    
	}
SceneHistory.prototype.convertArabicNumber = function (page) {
    alert("SceneHistory.convertArabicNumber()");
    this.ar_page=[];
    for (var i=0;i<=page.length;i++){
    switch (page[i]){
    
    	case '0' : this.ar_page[i]='٠';
    	break;
    	
    	case '1' : this.ar_page[i]='١';
    	break;
    	
    	case '2' : this.ar_page[i]='٢';
    	break;
    	
    	case '3' : this.ar_page[i]='٣';
    	break;
    	
    	case '4' : this.ar_page[i]='٤';
    	break;
    	
    	case '5' : this.ar_page[i]='٥';
    	break;
    	
    	case '6' : this.ar_page[i]='٦';
    	break;
    	
    	case '7' : this.ar_page[i]='٧';
    	break;
    	
    	case '8' : this.ar_page[i]='٨';
    	break;
    	
    	case '9' : this.ar_page[i]='٩';
    	break;
    }}
    if(page.length==1){
    	return this.ar_page[0];
    }
    else{
    	 return (this.ar_page[0]+this.ar_page[1]);
    }
   
}
//Handling Mouse Events
upNavigation = function(){
	var _THIS_=sf.scene.get('History');
	_THIS_.upNavigation();
}
downNavigation = function(){
	var _THIS_=sf.scene.get('History');
	_THIS_.downNavigation();
}
//End handling.
SceneHistory.prototype.upNavigation = function(){
	//This function handle up remote controller event & up voice command. 
	 if(EnglishFlag){
		 if(this.adFocus){
			 this.adFocus=false;
			 $("#Ad_banner").sfAdHubView({
					order:"unfocus",
				});
		 }
		 else if(this.enupPages<0){
			 	this.enupPages++;
			 	this.endownPages--;
		     	$('#enHistoryDescription').addClass('position');
		     	this.top=this.scrollSize*this.enupPages;
		     	$('#enHistoryDescription').css("top", this.top);
		     	$('#enHistoryScroll').sfScroll('prev');
		     	//Updating Current Page Number
		     	$('#enCurrentPage').text(Math.abs(this.enupPages)+1);
		 }
	 }
	 else{
		 if(this.adFocus){
			 this.adFocus=false;
			 $("#Ad_banner").sfAdHubView({
					order:"unfocus",
				});
		 }
		 else if(this.arupPages<0){
		 this.arupPages++;
	     this.ardownPages--;
		 $('#arHistoryDescription').addClass('position');
		 this.top=this.scrollSize*this.arupPages;
		 alert(this.top);
		 $('#arHistoryDescription').css("top", this.top);
		 $('#arHistoryScroll').sfScroll('prev');
		//Updating Current Page Number
		 $('#arCurrentPage').text(this.convertArabicNumber((Math.abs(this.arupPages)+1).toString()));
		 }
	 }
}
SceneHistory.prototype.downNavigation = function(){
	//This function handle down remote controller event & down voice command. 
	if(EnglishFlag){ //in case English Content
		if(this.endownPages<this.pages-1) { 
				this.endownPages++;
				this.enupPages--;
				$('#enHistoryDescription').removeClass('relative').addClass('position');
				this.top=-this.scrollSize*this.endownPages;
				alert(this.top);
				$('#enHistoryDescription').css("top",this.top );
				$('#enHistoryScroll').sfScroll('next');
				//Updating Current Page Number
				$('#enCurrentPage').text(Math.abs(this.endownPages)+1);
		}
		else{  //focus on Ad Banner.
				if(!this.adFocus){
						this.adFocus=true;
						$("#Ad_banner").sfAdHubView({
													order:"focus",
													border:2
													});
						//To Avoid Banner 1px moving.
						$("#Ad_banner").css({"top":"499px",
											 "left":"319px"});
									}
		}		
	}
	else{ //in case Arabic Content
				if(this.ardownPages<this.pages-1) { 
					this.ardownPages++;
					this.arupPages--;
					$('#arHistoryDescription').removeClass('relative').addClass('position');
					this.top=-this.scrollSize*this.ardownPages;
					alert(this.top);
    				$('#arHistoryDescription').css("top",this.top );
    				$('#arHistoryScroll').sfScroll('next');
    				//Updating Current Page Number
    				 $('#arCurrentPage').text(this.convertArabicNumber((Math.abs(this.ardownPages)+1).toString()));
													}
				else{
					if(!this.adFocus){
							this.adFocus=true;
							$("#Ad_banner").sfAdHubView({
														order:"focus",
														border:2
														});
							//To Avoid Banner 1px moving.
							$("#Ad_banner").css({"top":"499px",
												 "left":"319px"});
										}
					}
	}
}

SceneHistory.prototype.returnNavigation = function(){
	//This function handle return remote controller event & return voice command.
	/*
	if (deviceapis.recognition) {//unsubscribe Event handlers
		deviceapis.recognition.UnsubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "History");
	}
*/
	//For Scrolling Issue
	$('#enHistoryDescription').removeClass('position').addClass('relative');
	$('#arHistoryDescription').removeClass('position').addClass('relative');
	$("#Ad_banner").sfAdHubView({
		order:"stop"
	});
	sf.scene.hide('History');
	sf.scene.show('Main');
	sf.scene.focus('Main');
	sf.key.preventDefault();
}

//handling Mouse Click over Ad Banner
microsite = function(){
	AdFlag=true;
	//For Scrolling Issue
	if(EnglishFlag){$('#enHistoryDescription').removeClass('position').addClass('relative');}
	else{$('#arHistoryDescription').removeClass('position').addClass('relative');}
	//
$("#Ad_banner").sfAdHubView({
	order:"click"
});
}
//
SceneHistory.prototype.handleKeyDown = function (keyCode) {
	alert("SceneHistory.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	switch (keyCode) {
		case sf.key.LEFT:
			break;
			
		case sf.key.RIGHT:
			break;
		case sf.key.UP:
			alert("UP"+sf.key.UP);
			this.upNavigation();
			break;
		case sf.key.DOWN:
			alert("DOWN"+sf.key.DOWN);
        this.downNavigation();
			break;
			
		case sf.key.ENTER:
			alert("ENTER"+sf.key.ENTER);
			if(this.adFocus){
				AdFlag=true;
				//For Scrolling Issue
				if(EnglishFlag){$('#enHistoryDescription').removeClass('position').addClass('relative');}
				else{$('#arHistoryDescription').removeClass('position').addClass('relative');}
				//
			$("#Ad_banner").sfAdHubView({
				order:"click"
			});
			}
			break;
			
		case sf.key.BLUE:
			alert("BLUE:"+sf.key.BLUE);
			if(this.adFocus){
				 this.adFocus=false;
				 $("#Ad_banner").sfAdHubView({
						order:"unfocus",
					});
			 }
			if(this.arabicLoaded){
			if(EnglishFlag){
				
				EnglishFlag=false;
				$('#HistoryKeyHelp').sfKeyHelp({
					'blue':'English',
					'updown':'تحريك',
					'return':'رجوع'
				});
				$('#enHistoryPage').css('display','none');
				$('#arHistoryPage').css('display','block');
				
				this.arabicLoaded=false;
				var _th=this;
				
				$('#enHistoryDescription').css('display','none');
				$('#arHistoryDescription').css('display','block');
				$('#enHistoryTitle').css('display','none');
				$('#arHistoryTitle').css('display','block');
				setTimeout(function(){_th.arabicLoaded=true},700);
			   this.adjustScrollBar();
			}
			else{
				EnglishFlag=true;
				$('#HistoryKeyHelp').sfKeyHelp({
					'blue':'عربى',
					'updown':'Scroll',
					'return':'Return'
				});
				$('#arHistoryPage').css('display','none');
				$('#enHistoryPage').css('display','block');
				
				$('#HistoryLoading').sfLoading('show');
				$('#arHistoryDescription').css('display','none');
				$('#enHistoryDescription').css('display','block');
				$('#arHistoryTitle').css('display','none');
				$('#enHistoryTitle').css('display','block');
				$('#HistoryLoading').sfLoading('hide');
		    	this.adjustScrollBar();
			}
			}
			break;
			
		case sf.key.RETURN:
			alert("RETURN:"+sf.key.RETURN);
			this.returnNavigation();
			sf.key.preventDefault();
			break;
	}
}