/**
* @file      Location.js
* @brief     This Scene Display SlideShow with information about Egyptian Location.
* @author    Moataz Abdallh
* @date      20 june 2013
*/

alert('SceneLocation.js loaded');

function SceneLocation() {
	this.arrayNileValley = null; // Array to store Information (Title , Description) of the location.
	this.arrayMediterranean = null;
	this.arrayWesternDesert = null;
	this.arrayRedSea = null;
	this.sliderPaused = false; // the flag triggered when the slider paused.
	this.pages = 0;
	this.scrollSize = 180;
	this.encurrentPage = 0;
	this.arcurrentPage = 0;
	this.imageArray = null; // Array to store Image URL.
	this.index = 0; // this for index of the entered location
	this.enLocationDescription=null;
	this.enLocationDescription=null;
	this.arLocationDescription=null;
	this.arLocationDescription=null;
	this.i=0;
	this.date=null; // for image timestamp.
	this.loadedCount=0; //to count no. of images loaded.
	this.scrollDown=null;
	this.entered=false;
}

SceneLocation.prototype.initialize = function () {
	alert("SceneLocation.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
	
	$('#LocationKeyHelp').sfKeyHelp({
									'blue':'عربى',
									'yellow':'Map',
									'leftright':'Slideshow Navigation',
									'pause':'',
									'play':'',
									'return':'Return'
								});
	var _THIS_=this;
	
	 //NileValley XML
		this.arrayNileValley = [];
		
	    $.ajax({
	        type: "get"
	        ,dataType: "xml"
	        ,url: "xml/NileValley.xml"
	        ,success: function(xml){
			
	            if($(xml).find("item").length > 0){ // null check
				
	                $(xml).find("item").each(function(){ // loop
	                    var l_ar_title = $(this).find("ar_title").text();
	                    var l_ar_description = $(this).find("ar_description").text(); 
	                    var l_en_title = $(this).find("en_title").text();
	                    var l_en_description = $(this).find("en_description").text(); 

	                    var lArticle = {};
	                    lArticle.ar_title = l_ar_title;
	                    lArticle.ar_description = l_ar_description;
	                    lArticle.en_title= l_en_title;
	                    lArticle.en_description= l_en_description;
	            
	                    _THIS_.arrayNileValley.push(lArticle);					
	                });      
	                
	            }
	        }
	        ,error: function(){ alert("xml error!!");  }
	    });

		//Mediterranean XML
		this.arrayMediterranean = [];
		
	    $.ajax({
	        type: "get"
	        ,dataType: "xml"
	        ,url: "xml/Mediterranean.xml"
	        ,success: function(xml){
	            if($(xml).find("item").length > 0){ // null check
	                $(xml).find("item").each(function(){ // loop
	                    var l_ar_title = $(this).find("ar_title").text();
	                    var l_ar_description = $(this).find("ar_description").text(); 
	                    var l_en_title = $(this).find("en_title").text();
	                    var l_en_description = $(this).find("en_description").text(); 
	                    
	                    var lArticle = {};
	                    lArticle.ar_title = l_ar_title;
	                    lArticle.ar_description = l_ar_description;
	                    lArticle.en_title= l_en_title;
	                    lArticle.en_description= l_en_description;
	            
	                    _THIS_.arrayMediterranean.push(lArticle);                          
	                });      
	                
	            }
	        }
	        ,error: function(){ alert("xml error!!"); }
	    });

		 //WesternDesert XML
		this.arrayWesternDesert = [];
		
	    $.ajax({
	        type: "get"
	        ,dataType: "xml"
	        ,url: "xml/WesternDesert.xml"
	        ,success: function(xml){
	            if($(xml).find("item").length > 0){ // null check
	                $(xml).find("item").each(function(){ // loop
	                    var l_ar_title = $(this).find("ar_title").text();
	                    var l_ar_description = $(this).find("ar_description").text(); 
	                    var l_en_title = $(this).find("en_title").text();
	                    var l_en_description = $(this).find("en_description").text(); 
	                    
	                    var lArticle = {};
	                    lArticle.ar_title = l_ar_title;
	                    lArticle.ar_description = l_ar_description;
	                    lArticle.en_title= l_en_title;
	                    lArticle.en_description= l_en_description;
	            
	                    _THIS_.arrayWesternDesert.push(lArticle);                          
	                });      
	                
	            }
	        }
	        ,error: function(){ alert("xml error!!"); }
	    });

		//Red Sea XML
		this.arrayRedSea = [];
		
	    $.ajax({
	        type: "get"
	        ,dataType: "xml"
	        ,url: "xml/RedSea.xml"
	        ,success: function(xml){
	            if($(xml).find("item").length > 0){ // null check
	                $(xml).find("item").each(function(){ // loop
	                    var l_ar_title = $(this).find("ar_title").text();
	                    var l_ar_description = $(this).find("ar_description").text(); 
	                    var l_en_title = $(this).find("en_title").text();
	                    var l_en_description = $(this).find("en_description").text(); 
	                    
	                    var lArticle = {};
	                    lArticle.ar_title = l_ar_title;
	                    lArticle.ar_description = l_ar_description;
	                    lArticle.en_title= l_en_title;
	                    lArticle.en_description= l_en_description;
	            
	                    _THIS_.arrayRedSea.push(lArticle);                          
	                });      
	                
	            }
	        }
	        ,error: function(){ alert("xml error!!"); }
	    });
	
		this.enLocationDescription = document.getElementById('enLocationDescription');
		this.enLocationFrame = document.getElementById('enLocationFrame');
		this.arLocationDescription = document.getElementById('arLocationDescription');
		this.arLocationFrame = document.getElementById('arLocationFrame');
		this.date= new Date();

}

SceneLocation.prototype.handleShow = function (data) {
	alert("SceneLocation.handleShow()");
	// this function will be called when the scene manager show this scene 
	this.entered=true;
	this.imageArray = [];
	var _THIS_=this;
	var scenemaps = sf.scene.get('Maps');
	
	switch(scenemaps.index){
	case 1:
		var scenenillevalley=sf.scene.get('NileValley');
		this.index=scenenillevalley.HighlightIndex;
		for(var i=0;i<5;i++){
			this.imageArray[i]="http://esprit-solutions.com/apps/egypt/1/"+this.index+"/"+i+".jpg?x="+this.date.getTime(); //using timestamp to avoid image chaching.
			
		}
		
	    //wrapping XML information inside HTML Elements. 
	    setTimeout(function(){
	    	
	    	$('#enLocationDescription').html("<p>"+_THIS_.arrayNileValley[_THIS_.index].en_description+"</p>").removeClass('Ar').addClass('En');
	    	$('#arLocationDescription').html("<p>"+_THIS_.arrayNileValley[_THIS_.index].ar_description+"</p>").removeClass('En').addClass('Ar');
	    	$('#enLocationTitle').html ("<h1>"+_THIS_.arrayNileValley[_THIS_.index].en_title+"</h1>").css('direction','ltr');
	    	$('#arLocationTitle').html ("<h1>"+_THIS_.arrayNileValley[_THIS_.index].ar_title+"</h1>").css('direction','rtl'); 
	    	if(EnglishFlag){
	    		$('#arLocationTitle').css('display','none');
	        	$('#arLocationDescription').css('display','none');
	        	$('#enLocationTitle').css('display','block');  		
	    		$('#enLocationDescription').css('display','block');
	        	
	    	}
	    	else{
	    		$('#enLocationTitle').css('display','none');  		
	    		$('#enLocationDescription').css('display','none');
	    		$('#arLocationTitle').css('display','block');
	        	$('#arLocationDescription').css('display','block');
	    	}
	    	_THIS_.adjustScrollBar();},500);
		break;
	case 2:
		var scenemediterranean=sf.scene.get('Mediterranean');
		this.index=scenemediterranean.HighlightIndex;
		for(var i=0;i<5;i++){
			this.imageArray[i]="http://esprit-solutions.com/apps/egypt/2/"+this.index+"/"+i+".jpg?x="+this.date.getTime();
		}
		
	    //wrapping XML information inside HTML Elements. 
	    setTimeout(function(){
	    	
	    	$('#enLocationDescription').html("<p>"+_THIS_.arrayMediterranean[_THIS_.index].en_description+"</p>").removeClass('Ar').addClass('En');
	    	$('#arLocationDescription').html("<p>"+_THIS_.arrayMediterranean[_THIS_.index].ar_description+"</p>").removeClass('En').addClass('Ar');
	    	$('#enLocationTitle').html ("<h1>"+_THIS_.arrayMediterranean[_THIS_.index].en_title+"</h1>").css('direction','ltr');
	    	$('#arLocationTitle').html ("<h1>"+_THIS_.arrayMediterranean[_THIS_.index].ar_title+"</h1>").css('direction','rtl'); 
	    	if(EnglishFlag){
	    		$('#arLocationTitle').css('display','none');
	        	$('#arLocationDescription').css('display','none');
	        	$('#enLocationTitle').css('display','block');  		
	    		$('#enLocationDescription').css('display','block');
	        	
	    	}
	    	else{
	    		$('#enLocationTitle').css('display','none');  		
	    		$('#enLocationDescription').css('display','none');
	    		$('#arLocationTitle').css('display','block');
	        	$('#arLocationDescription').css('display','block');
	    	}
	    	_THIS_.adjustScrollBar();},500);
		break;
	case 3:
		var scenewesterndesert=sf.scene.get('WesternDesert');
		this.index=scenewesterndesert.HighlightIndex;
		for(var i=0;i<5;i++){
			this.imageArray[i]="http://esprit-solutions.com/apps/egypt/3/"+this.index+"/"+i+".jpg?x="+this.date.getTime();
		}
	    //wrapping XML information inside HTML Elements. 
	    setTimeout(function(){
	    	
	    	$('#enLocationDescription').html("<p>"+_THIS_.arrayWesternDesert[_THIS_.index].en_description+"</p>").removeClass('Ar').addClass('En');
	    	$('#arLocationDescription').html("<p>"+_THIS_.arrayWesternDesert[_THIS_.index].ar_description+"</p>").removeClass('En').addClass('Ar');
	    	$('#enLocationTitle').html ("<h1>"+_THIS_.arrayWesternDesert[_THIS_.index].en_title+"</h1>").css('direction','ltr');
	    	$('#arLocationTitle').html ("<h1>"+_THIS_.arrayWesternDesert[_THIS_.index].ar_title+"</h1>").css('direction','rtl'); 
	    	if(EnglishFlag){
	    		$('#arLocationTitle').css('display','none');
	        	$('#arLocationDescription').css('display','none');
	        	$('#enLocationTitle').css('display','block');  		
	    		$('#enLocationDescription').css('display','block');
	        	
	    	}
	    	else{
	    		$('#enLocationTitle').css('display','none');  		
	    		$('#enLocationDescription').css('display','none');
	    		$('#arLocationTitle').css('display','block');
	        	$('#arLocationDescription').css('display','block');
	    	}
	    	_THIS_.adjustScrollBar();},500);
		break;
	case 4:
		var sceneredsea=sf.scene.get('RedSea');
		this.index=sceneredsea.HighlightIndex;
		for(var i=0;i<5;i++){
			this.imageArray[i]="http://esprit-solutions.com/apps/egypt/4/"+this.index+"/"+i+".jpg?x="+this.date.getTime();
		}
	    //wrapping XML information inside HTML Elements. 
	    setTimeout(function(){
	    	
	    	$('#enLocationDescription').html("<p>"+_THIS_.arrayRedSea[_THIS_.index].en_description+"</p>").removeClass('Ar').addClass('En');
	    	$('#arLocationDescription').html("<p>"+_THIS_.arrayRedSea[_THIS_.index].ar_description+"</p>").removeClass('En').addClass('Ar');
	    	$('#enLocationTitle').html ("<h1>"+_THIS_.arrayRedSea[_THIS_.index].en_title+"</h1>").css('direction','ltr');
	    	$('#arLocationTitle').html ("<h1>"+_THIS_.arrayRedSea[_THIS_.index].ar_title+"</h1>").css('direction','rtl'); 
	    	if(EnglishFlag){
	    		$('#arLocationTitle').css('display','none');
	        	$('#arLocationDescription').css('display','none');
	        	$('#enLocationTitle').css('display','block');  		
	    		$('#enLocationDescription').css('display','block');
	        	
	    	}
	    	else{
	    		$('#enLocationTitle').css('display','none');  		
	    		$('#enLocationDescription').css('display','none');
	    		$('#arLocationTitle').css('display','block');
	        	$('#arLocationDescription').css('display','block');
	    	}
	    	_THIS_.adjustScrollBar();},500);
		break;
	}
	
     //KeyHelpLanguage
	if(EnglishFlag){
		$('#LocationKeyHelp').sfKeyHelp({
			'blue':'عربى',
			'yellow':'Map',
			'leftright':'Slideshow Navigation',
			'pause':'',
			'play':'',
			'return':'Return'
		});
	}
	else{
		$('#LocationKeyHelp').sfKeyHelp({
			'blue':'English',
			'yellow':'الخريطة',
			'leftright':'تحريك الصور',
			'play':'',
			'pause':'',
			'return':'رجوع'
		});
	}
     //SlideShow
	 $('#LocationLoading').sfLoading('show'); //Showing Loading Icon   
	 $('#container').append("<div id='coin-slider"+this.i+"'></div>"); //creating new slider everytime entering
	 
	for(var i=0;i<5;i++){ //Storing Images URL in ImageArray
					$('#coin-slider'+this.i).append("<a href='#'><img id='img"+i+"' src='"+this.imageArray[i]+"'></a>");
						}
	
	 $('#coin-slider'+this.i).coinslider({ width: 675,height:380, navigation: true, delay:5000,effect:'straight',spw:'1',sph:'1',hoverPause: true});
	 $('#container a').trigger('mouseover');
	 this.sliderPaused = true;
	 
	 $('#img0').load(function(){
		 _THIS_.loadedCount++;
		 alert("loadeddddddddd");
	 });
	 $('#img1').load(function(){
		 _THIS_.loadedCount++;
		 alert("loadeddddddddd");
	 });
	 $('#img2').load(function(){
		 _THIS_.loadedCount++;
		 alert("loadeddddddddd");
	 });
	 $('#img3').load(function(){
		 _THIS_.loadedCount++;
		 alert("loadeddddddddd");
	 });
	 $('#img4').load(function(){
		 alert("loadeddddddddd");
	 });
	
	 var interval=setInterval(function(){
		 
		 if(_THIS_.loadedCount>1){ // when image loading completed hide loading icon then display slideshow
				$('#LocationLoading').sfLoading('hide');
				$('.slideshow').css('display','block');
				$('.cs-buttons').css('display','block');
				$('#container a').trigger('mouseout');
				 _THIS_.sliderPaused = false;
				 clearInterval(interval);
				}; 
	 },1000);
	 
	 
	 $('#coin-slider'+this.i+' img').error(function(){ //if Image Error occurs so hide loading icon hide slideshow then appear error notification message
		 	$('#LocationLoading').sfLoading('hide');
		 	$('.slideshow').css('display','none');
		 	$('.cs-buttons').css('display','none');
		 	if (EnglishFlag){
		 		$('#Notification img').attr('src','images/enNotification.png');
		 		$('#Notification').css('display','block');
		 	}
		 	else{
		 		$('#Notification img').attr('src','images/arNotification.png');
		 		$('#Notification').css('display','block');
		 	}
	 });
		//END of SlideShow.

	      window.addEventListener('DOMMouseScroll', wheel, false);
	      window.onmousewheel = document.onmousewheel = wheel;
	      
	  	//Checking Voice support
	      if(!AdFlag){
	 	 if (deviceapis.recognition.IsRecognitionSupported()) {
	 			deviceapis.recognition.SubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "Location", handleLocationRecognitionEvent);
	 		} 
	 		else {
	 			alert("ERROR: Voice recognition not supported");
	 		}
	 	 var locationHelpbar = {
	 				helpbarType: "HELPBAR_TYPE_VOICE_CUSTOMIZE",
	 				bKeepCurrentInfo: "false",
	 				helpbarItemsList: [
	 					{ itemText: "Left", commandList: [{command: "Left"}]},
	 					{ itemText: "Right", commandList: [{command: "Right"}]},
	 					{ itemText: "Map", commandList: [{command: "Map"}]},
	 					{ itemText: "Return", commandList: [{command: "Return"}]},
	 					]
	 		};
	 		deviceapis.recognition.SetVoiceHelpbarInfo(JSON.stringify(locationHelpbar));
}
}
//Handling Voice commands
handleLocationRecognitionEvent= function (evt) {
	var _THIS_=sf.scene.get('Location');
	switch (evt.eventtype) {
		case "EVENT_VOICE_BEGIN_MONITOR":
		case "EVENT_VOICE_BTSOUND_START":
			break;
		case "EVENT_VOICE_RECOG_RESULT":
			switch (evt.result.toLowerCase()) {
			case "left": _THIS_.leftNavigation(); break;
			case "right": _THIS_.rightNavigation(); break;
			case "map": _THIS_.mapNavigation(); break;
			case "return": _THIS_.returnNavigation(); break;
		}
			break;
	}
}
//END Voice handling
function wheel(e) {
	  e.preventDefault();
	  var _THIS_ = sf.scene.get('Location');
	  if(e.wheelDelta<0){ //this means scrolling down
	  if(EnglishFlag){
			_THIS_.encurrentPage++;
				if(_THIS_.encurrentPage>=_THIS_.pages) { 
						_THIS_.encurrentPage=_THIS_.pages-1;
													}
				
				$('#enLocationDescription').addClass('position');
				$('#enLocationDescription').css("top", (-_THIS_.scrollSize)*_THIS_.encurrentPage);
				$('#enLocationScroll').sfScroll('next');
				
	}
	else{
			_THIS_.arcurrentPage++;
				if(_THIS_.arcurrentPage>=_THIS_.pages) { 
						_THIS_.arcurrentPage=_THIS_.pages-1;
													}
				
				$('#arLocationDescription').addClass('position');
				$('#arLocationDescription').css("top", (-_THIS_.scrollSize)*_THIS_.arcurrentPage);
				$('#arLocationScroll').sfScroll('next');		
	}
	}
	  else{ //this means scrolling up
		  if(EnglishFlag){
			  _THIS_.encurrentPage--;
				 if(_THIS_.encurrentPage<0){
					 _THIS_.encurrentPage=0;
					 	}
         	$('#enLocationDescription').addClass('position');
         	$('#enLocationDescription').css("top", (_THIS_.scrollSize)*_THIS_.encurrentPage);
         	$('#enLocationScroll').sfScroll('prev');
			 }
			 else{
				 _THIS_.arcurrentPage--;
				 if(_THIS_.arcurrentPage<0){
					 _THIS_.arcurrentPage=0;
					 	}
				 $('#arLocationDescription').addClass('position');
				 $('#arLocationDescription').css("top", (_THIS_.scrollSize)*_THIS_.arcurrentPage);
				 $('#arLocationScroll').sfScroll('prev');
			 }
	  }
}

SceneLocation.prototype.handleHide = function () {
	alert("SceneLocation.handleHide()");
	// this function will be called when the scene manager hide this scene  
}

SceneLocation.prototype.handleFocus = function () {
	alert("SceneLocation.handleFocus()");
	// this function will be called when the scene manager focus this scene
}

SceneLocation.prototype.handleBlur = function () {
	alert("SceneLocation.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneLocation.prototype.adjustScrollBar = function () {
    alert("SceneLocation.adjustScrollBar()");
    var articleLength = null;
    var frameLength = null;
    if(EnglishFlag){
    		articleLength = this.enLocationDescription.scrollHeight;
    		frameLength = this.enLocationFrame.offsetHeight;
    }
    else{
    	articleLength = this.arLocationDescription.scrollHeight;
		frameLength = this.arLocationFrame.offsetHeight;
    }
    this.pages = Math.ceil(((articleLength - frameLength) / this.scrollSize) + 1);	
    alert("this.pages == "+this.pages+" articleLength == "+articleLength+" frameLength == "+frameLength);
    if(this.pages < 0) {
    	this.pages = 0;
    }
    
    if(this.pages <= 1) {
    	this.hideScrollBar();
    }
    else {
    	this.showScrollBar();
    }    	    
		 }

SceneLocation.prototype.showScrollBar = function () {
    alert("SceneLocation.showScrollBar()");

	
    if(EnglishFlag){
    	$('#arLocationScroll').sfScroll('hide');
    	$('#enLocationScroll').sfScroll({ pages:this.pages});
    	$('#enLocationScroll').css('right','30px');
    	$('#enLocationScroll').sfScroll('move',this.encurrentPage);
    	$('#enLocationScroll').sfScroll('show');
    }
    else{
    	$('#enLocationScroll').sfScroll('hide');
    	$('#arLocationScroll').sfScroll({ pages:this.pages});
    	$('#arLocationScroll').css('left','30px');
    	$('#arLocationScroll').sfScroll('move',this.arcurrentPage);
    	$('#arLocationScroll').sfScroll('show');
    }
	
	}
SceneLocation.prototype.hideScrollBar = function () {
    alert("SceneLocation.hideScrollBar()");

    	 $('#enLocationScroll').sfScroll('hide');

    	 $('#arLocationScroll').sfScroll('hide');
    
	}

SceneLocation.prototype.rightNavigation = function(){
	//This function handle right remote controller event & right voice command. 
	if(this.sliderPaused){ // in case the slider is paused so u must untrigger the slider hover then do next slide click & then pause the slider again
		$('#container a').trigger('mouseout');
		$('.cs-next').trigger('click');
		$('#container a').trigger('mouseover');
	}
	else{
		$('.cs-next').trigger('click');
	}
}
SceneLocation.prototype.leftNavigation = function(){
	//This function handle left remote controller event & left voice command. 
	if(this.sliderPaused){ // in case the slider is paused so u must untrigger the slider hover then do next slide click & then pause the slider again
		$('#container a').trigger('mouseout');
		$('.cs-prev').trigger('click');
		$('#container a').trigger('mouseover');
	}
	else{
	$('.cs-prev').trigger('click');
	}  
}

SceneLocation.prototype.mapNavigation = function(){
	//This function handle yellow remote controller event & map voice command.
	//intialization
		if(!AdFlag){
		if (deviceapis.recognition) { //unsubscribe Event handlers
			deviceapis.recognition.UnsubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "Location");
		}
		}
	this.loadedCount=0;
	$('#LocationLoading').sfLoading('hide'); 
	$('#enLocationDescription').removeClass('position'); //this to solve position issue
	$('#arLocationDescription').removeClass('position');
	this.arcurrentPage=0;
	this.encurrentPage=0;
	this.hideScrollBar();
	$('#enLocationTitle').html('');
	$('#arLocationTitle').html('');
	$('#enLocationDescription').html('');
	$('#arLocationDescription').html('');
	$('.cs-buttons').css('display','none');
	$('.slideshow').css('display','none');
	$('#coin-slider-coin-slider'+this.i).remove();
	this.i++;
	$('#Notification').css('display','none');
	this.entered=false;
	
	sf.scene.hide('Location');
	sf.scene.show('GoogleMap');
	sf.scene.focus('GoogleMap');
}

SceneLocation.prototype.returnNavigation = function(){
	//This function handle return remote controller event & return voice command.
	if(!AdFlag){
	if (deviceapis.recognition) {//unsubscribe Event handlers
		deviceapis.recognition.UnsubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "Location");
		deviceapis.recognition.HideVoiceHelpbar();
	}
	}
	//intialization
	this.loadedCount=0;
	$('#LocationLoading').sfLoading('hide'); 
	$('#enLocationDescription').removeClass('position'); //this to solve position issue
	$('#arLocationDescription').removeClass('position');
	this.arcurrentPage=0;
	this.encurrentPage=0;
	this.hideScrollBar();
	$('#enLocationTitle').html('');
	$('#arLocationTitle').html('');
	$('#enLocationDescription').html('');
	$('#arLocationDescription').html('');
	$('.cs-buttons').css('display','none');
	$('.slideshow').css('display','none');
	$('#coin-slider-coin-slider'+this.i).remove();
	this.i++;
	$('#Notification').css('display','none');
	this.entered=false;
	var mapscene = sf.scene.get('Maps');
	sf.scene.hide('Location');
	switch(mapscene.index){
	case 1:
		sf.scene.show('NileValley');
		sf.scene.focus('NileValley');
		break;
	case 2:
		sf.scene.show('Mediterranean');
		sf.scene.focus('Mediterranean');
		break;
	case 3:
		sf.scene.show('WesternDesert');
		sf.scene.focus('WesternDesert');
		break;
	case 4:
		sf.scene.show('RedSea');
		sf.scene.focus('RedSea');
		break;
	}
	sf.key.preventDefault();
	
}
SceneLocation.prototype.handleKeyDown = function (keyCode) {
	alert("SceneLocation.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	switch (keyCode) {
		case sf.key.LEFT:
			alert("LEFT"+sf.key.LEFT);
			this.leftNavigation();
			break;
			
		case sf.key.RIGHT:
			alert("RIGHT"+sf.key.RIGHT);
			this.rightNavigation();
			break;
			
		case sf.key.UP:
			alert("UP"+sf.key.UP);
				 if(EnglishFlag){
					 this.encurrentPage--;
					 if(this.encurrentPage<0){
						 	this.encurrentPage=0;
						 	}
	            	$('#enLocationDescription').addClass('position');
	            	$('#enLocationDescription').css("top", (this.scrollSize)*this.encurrentPage);
	            	$('#enLocationScroll').sfScroll('prev');
				 }
				 else{
					 this.arcurrentPage--;
					 if(this.arcurrentPage<0){
						 	this.arcurrentPage=0;
						 	}
					 $('#arLocationDescription').addClass('position');
					 $('#arLocationDescription').css("top", (this.scrollSize)*this.arcurrentPage);
					 $('#arLocationScroll').sfScroll('prev');
				 }
			break;
		case sf.key.DOWN:
			alert("DOWN"+sf.key.DOWN);
			
            	if(EnglishFlag){
            			this.encurrentPage++;
            				if(this.encurrentPage>=this.pages) { 
            						this.encurrentPage=this.pages-1;
            													}
            				
            				$('#enLocationDescription').addClass('position');
            				$('#enLocationDescription').css("top", (-this.scrollSize)*this.encurrentPage);
            				$('#enLocationScroll').sfScroll('next');
            				
            	}
            	else{
            			this.arcurrentPage++;
            				if(this.arcurrentPage>=this.pages) { 
            						this.arcurrentPage=this.pages-1;
            													}
            				
            				$('#arLocationDescription').addClass('position');
            				$('#arLocationDescription').css("top", (-this.scrollSize)*this.arcurrentPage);
            				$('#arLocationScroll').sfScroll('next');		
            	}
			break;
			
		case sf.key.ENTER:

			break;
			
		case sf.key.PLAY:
			alert("PLAY"+sf.key.PLAY);
			$('#container a').trigger('mouseout');
			this.sliderPaused = false;
			break;
			
		case sf.key.PAUSE:
			alert("PAUSE"+sf.key.PAUSE);
			$('#container a').trigger('mouseover');
			this.sliderPaused = true;
			break;
			
		case sf.key.BLUE:
			alert("BLUE:"+sf.key.BLUE);
			if(EnglishFlag){
				EnglishFlag=false;
				$('#LocationKeyHelp').sfKeyHelp({
					'blue':'English',
					'yellow':'الخريطة',
					'leftright':'تحريك الصور',
					'play':'',
					'pause':'',
					'return':'رجوع'
				});
				$('#enLocationDescription').css('display','none');
				$('#arLocationDescription').css('display','block');
				$('#enLocationTitle').css('display','none');
				$('#arLocationTitle').css('display','block');
				
				//Chnging next/prev slidshow buttons
				$('#cs-navigation-coin-slider'+this.i+' a.cs-prev').text("السابق");
				$('#cs-navigation-coin-slider'+this.i+' a.cs-next').text("التالى");
			   
			   this.adjustScrollBar();
			}
			else{
				EnglishFlag=true;
				$('#LocationKeyHelp').sfKeyHelp({
					'blue':'عربى',
					'yellow':'Map',
					'leftright':'Slideshow Navigation',
					'pause':'',
					'play':'',
					'return':'Return'
				});
				$('#arLocationDescription').css('display','none');
				$('#enLocationDescription').css('display','block');
				$('#arLocationTitle').css('display','none');
				$('#enLocationTitle').css('display','block');
		    	
				//Chnging next/prev slidshow buttons
				$('#cs-navigation-coin-slider'+this.i+' a.cs-prev').text("prev");
				$('#cs-navigation-coin-slider'+this.i+' a.cs-next').text("next");
		    	this.adjustScrollBar();
			}
			break;
		case sf.key.YELLOW:
			alert("YELLOW:"+sf.key.YELLOW);
			this.mapNavigation();
			break;
			
		case sf.key.RETURN:
			alert("RETURN:"+sf.key.RETURN);
			this.returnNavigation();
			sf.key.preventDefault();
			break;
	}
}