/**
* @file      Main.js
* @brief     This Scene is the main Display.
* @author    Moataz Abdallh
* @date      22 May 2013
*/

alert('SceneMain.js loaded');

function SceneMain() {
	this.index=0;
}

SceneMain.prototype.initialize = function () {
	alert("SceneMain.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called								  
}

SceneMain.prototype.handleShow = function (data) {
	alert("SceneMain.handleShow()");
	// this function will be called when the scene manager show this scene 
	if(EnglishFlag){
		$('#MainKeyHelp').sfKeyHelp({
			'blue':'عربى',
			'leftright':'Navigation',
			'enter':'Enter',
			'return':'Return'
		});
		$('#MainNav').attr('src','images/enMain.png');
	}
	else{
		$('#MainKeyHelp').sfKeyHelp({
			'blue':'English',
			'leftright':'تحريك',
			'enter':'دخول',
			'return':'خروج'
		});
		$('#MainNav').attr('src','images/arMain.png');
	}
	if(!AdFlag){
	if (deviceapis.recognition.IsRecognitionSupported()) {
		deviceapis.recognition.SubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "Main", handleMainRecognitionEvent);
	} 
	else {
		alert("ERROR: Voice recognition not supported");
	}
	
	var mainHelpbar = {
			helpbarType: "HELPBAR_TYPE_VOICE_CUSTOMIZE",
			bKeepCurrentInfo: "false",
			helpbarItemsList: [
				{ itemText: "Left", commandList: [{command: "Left"}]},
				{ itemText: "Right", commandList: [{command: "Right"}]},
				{ itemText: "Open", commandList: [{command: "Open"}]},
				{ itemText: "Return", commandList: [{command: "Return"}]},
				{ itemText: "Exit", commandList: [{command: "Exit"}]}
				]
	};
	deviceapis.recognition.SetVoiceHelpbarInfo(JSON.stringify(mainHelpbar));
}
}
SceneMain.prototype.handleHide = function () {
	alert("SceneMain.handleHide()");
	// this function will be called when the scene manager hide this scene  
}

SceneMain.prototype.handleFocus = function () {
	alert("SceneMain.handleFocus()");
	// this function will be called when the scene manager focus this scene
}


SceneMain.prototype.handleBlur = function () {
	alert("SceneMain.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

//Handling Voice commands
handleMainRecognitionEvent= function (evt) {
	var _THIS_=sf.scene.get('Main');
	switch (evt.eventtype) {
		case "EVENT_VOICE_BEGIN_MONITOR":
		case "EVENT_VOICE_BTSOUND_START":
			break;
		case "EVENT_VOICE_RECOG_RESULT":
			switch (evt.result.toLowerCase()) {
			case "left": _THIS_.leftNavigation(); break;
			case "right": _THIS_.rightNavigation(); break;
			case "open": _THIS_.enterNavigation(); break;
			case "return": sf.core.exit(false); break;
			case "exit": sf.core.exit(true); break;
		}
			break;
	}
}
//END Voice handling

//Handling Click Event
videos=function(){
	if(!AdFlag){
		if (deviceapis.recognition) { //unsubscribe Event handlers
			deviceapis.recognition.UnsubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "Main");
			deviceapis.recognition.HideVoiceHelpbar();
		}
		}
	sf.scene.hide('Main');
	sf.scene.show('Player');
	sf.scene.focus('Player');
}
landscapes=function(){
	if(!AdFlag){
		if (deviceapis.recognition) { //unsubscribe Event handlers
			deviceapis.recognition.UnsubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "Main");
			deviceapis.recognition.HideVoiceHelpbar();
		}
		}
	sf.scene.hide('Main');
	sf.scene.show('Maps');
	sf.scene.focus('Maps');
}
history=function(){
	if(!AdFlag){
		if (deviceapis.recognition) { //unsubscribe Event handlers
			deviceapis.recognition.UnsubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "Main");
			deviceapis.recognition.HideVoiceHelpbar();
		}
		}
	sf.scene.hide('Main');
	sf.scene.show('History');
	sf.scene.focus('History');
}
//End handling
//Handling Mouseover
videosMouseover = function(){
	var scenemain = sf.scene.get('Main');
	scenemain.index=0;
	$('#camel1').css('display','none');
	$('#camel2').css('display','none');
	$('#camel0').css('display','block');
}
landscapesMouseover = function(){
	var scenemain = sf.scene.get('Main');
	scenemain.index=1;
	$('#camel0').css('display','none');
	$('#camel2').css('display','none');
	$('#camel1').css('display','block');
}
historyMouseover = function(){
	var scenemain = sf.scene.get('Main');
	scenemain.index=2;
	$('#camel1').css('display','none');
	$('#camel0').css('display','none');
	$('#camel2').css('display','block');
}
//End MouseOver

SceneMain.prototype.leftNavigation = function(){
	//This function handle left remote controller event & left voice command. 
	if(this.index>0){
		this.index--;
	}
	switch(this.index){
	case 1:
		$('#camel2').css('display','none');
		$('#camel1').css('display','block');
		break;
	case 0:
		$('#camel1').css('display','none');
		$('#camel0').css('display','block');
		break;
	}
}

SceneMain.prototype.rightNavigation = function(){
	//This function handle right remote controller event & right voice command. 
	if(this.index<2){
		this.index++;
	}
	switch(this.index){
	case 1:
		$('#camel0').css('display','none');
		$('#camel1').css('display','block');
		break;
	case 2:
		$('#camel1').css('display','none');
		$('#camel2').css('display','block');
		break;
	}
}

SceneMain.prototype.enterNavigation = function(){
	//This function handle enter remote controller event & open voice command. 
		if(!AdFlag){
		if (deviceapis.recognition) {//unsubscribe Event handlers
			deviceapis.recognition.UnsubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "Main");
		}}
	switch(this.index){
	case 0:
		sf.scene.hide('Main');
		sf.scene.show('Player');
		sf.scene.focus('Player');
		break;
	case 1:
		sf.scene.hide('Main');
		sf.scene.show('Maps');
		sf.scene.focus('Maps');
		break;
	case 2:
		sf.scene.hide('Main');
		sf.scene.show('History');
		sf.scene.focus('History');
		break;
	}
}
SceneMain.prototype.handleKeyDown = function (keyCode) {
	alert("SceneMain.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	switch (keyCode) {
		case sf.key.LEFT:
			alert("LEFT:"+sf.key.LEFT);
		    this.leftNavigation();
			break;
			
		case sf.key.RIGHT:
			alert("RIGHT:"+sf.key.RIGHT);
		this.rightNavigation();
			break;

		case sf.key.ENTER:
			alert("ENTER:"+sf.key.ENTER);
			this.enterNavigation();
			break;
		case sf.key.BLUE:
			alert("BLUE:"+sf.key.BLUE);
			if(EnglishFlag){
				EnglishFlag=false;
				$('#MainKeyHelp').sfKeyHelp({
					'blue':'English',
					'leftright':'تحريك',
					'enter':'دخول',
					'return':'خروج'
				});
				$('#MainNav').attr('src','images/arMain.png');
			}
			else{
				EnglishFlag=true;
				$('#MainKeyHelp').sfKeyHelp({
					'blue':'عربى',
					'leftright':'Navigation',
					'enter':'Enter',
					'return':'Return'
				});
				$('#MainNav').attr('src','images/enMain.png');
			}
			break;
		
}
}