alert('SceneMaps.js loaded');

function SceneMaps() {
	this.index=1; // Navigating Index.
}

SceneMaps.prototype.initialize = function () {
	alert("SceneMaps.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
	
	

}

SceneMaps.prototype.handleShow = function (data) {
	alert("SceneMaps.handleShow()");
	// this function will be called when the scene manager show this scene
	if(EnglishFlag){
		$('#MapsKeyHelp').sfKeyHelp({
			'blue':'عربى',
			'move':'Navigate',
			'enter':'Enter',
			'return':'Return'
		});
		$('#NileValleyThumbTitle').html("<p>NileValley</p>").removeClass('Arabic').addClass('English');
		$('#MediterraneanThumbTitle').html("<p>Mediterranean</p>").removeClass('Arabic').addClass('English');
		$('#RedSeaThumbTitle').html("<p>Red Sea</p>").removeClass('Arabic').addClass('English');
		$('#WesternDesertThumbTitle').html("<p>Western Desert</p>").removeClass('Arabic').addClass('English');
	}
	else{
		$('#MapsKeyHelp').sfKeyHelp({
			'blue':'English',
			'move':'تحريك',
			'enter':'دخول',
			'return':'رجوع'
		});
		$('#NileValleyThumbTitle').html("<p>وادى النيل</p>").removeClass('English').addClass('Arabic');
		$('#MediterraneanThumbTitle').html("<p>البحر الابيض المتوسط</p>").removeClass('English').addClass('Arabic');
		$('#RedSeaThumbTitle').html("<p>البحر الاحمر</p>").removeClass('English').addClass('Arabic');
		$('#WesternDesertThumbTitle').html("<p>الصحراء الغربية</p>").removeClass('English').addClass('Arabic');
	}
	
	//Checking Voice support
	if(!AdFlag){
	 if (deviceapis.recognition.IsRecognitionSupported()) {
			deviceapis.recognition.SubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "Maps", handleMapsRecognitionEvent);
			
		} 
		else {
			alert("ERROR: Voice recognition not supported");
		}
	 var mapsHelpbar = {
				helpbarType: "HELPBAR_TYPE_VOICE_CUSTOMIZE",
				bKeepCurrentInfo: "false",
				helpbarItemsList: [
					{ itemText: "Up", commandList: [{command: "Up"}]},
					{ itemText: "Down", commandList: [{command: "Down"}]},
					{ itemText: "Left", commandList: [{command: "Left"}]},
					{ itemText: "Right", commandList: [{command: "Right"}]},
					{ itemText: "Open", commandList: [{command: "Open"}]},
					{ itemText: "Return", commandList: [{command: "Return"}]},
					]
		};
		deviceapis.recognition.SetVoiceHelpbarInfo(JSON.stringify(mapsHelpbar));
}
}
//Handling Voice commands
handleMapsRecognitionEvent= function (evt) {
	var _THIS_=sf.scene.get('Maps');
	switch (evt.eventtype) {
		case "EVENT_VOICE_BEGIN_MONITOR":
		case "EVENT_VOICE_BTSOUND_START":
			break;
		case "EVENT_VOICE_RECOG_RESULT":
			switch (evt.result.toLowerCase()) {
			case "up": _THIS_.upNavigation(); break;
			case "down": _THIS_.downNavigation(); break;
			case "left": _THIS_.leftNavigation(); break;
			case "right": _THIS_.rightNavigation(); break;
			case "open": _THIS_.enterNavigation(); break;
			case "return": _THIS_.returnNavigation(); break;
		}
			break;
	}
}
//END Voice handling

SceneMaps.prototype.handleHide = function () {
	alert("SceneMaps.handleHide()");
	// this function will be called when the scene manager hide this scene  
}

SceneMaps.prototype.handleFocus = function () {
	alert("SceneMaps.handleFocus()");
	// this function will be called when the scene manager focus this scene
}

SceneMaps.prototype.handleBlur = function () {
	alert("SceneMaps.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

//Handling Mouse Over Event
nilevalleyMouseover = function(){
	var scenemaps=sf.scene.get('Maps');
	scenemaps.index=1;
	 $('#Mediterranean').css('opacity','0.2');
	 $('#RedSea').css('opacity','0.2');
	 $('#WesternDesert').css('opacity','0.2');
	 $('#NileValley').css('opacity','1');
}
mediterraneanMouseover = function(){
	var scenemaps=sf.scene.get('Maps');
	scenemaps.index=2;
	 $('#RedSea').css('opacity','0.2');
	 $('#WesternDesert').css('opacity','0.2');
	 $('#NileValley').css('opacity','0.2');
	 $('#Mediterranean').css('opacity','1');
}
redseaMouseover = function(){
	var scenemaps=sf.scene.get('Maps');
	scenemaps.index=4;
	 $('#Mediterranean').css('opacity','0.2');
	 $('#WesternDesert').css('opacity','0.2');
	 $('#NileValley').css('opacity','0.2');
	 $('#RedSea').css('opacity','1');
}
westerndesertMouseover = function(){
	var scenemaps=sf.scene.get('Maps');
	scenemaps.index=3;
	 $('#Mediterranean').css('opacity','0.2');
	 $('#RedSea').css('opacity','0.2');
	 $('#NileValley').css('opacity','0.2');
	 $('#WesternDesert').css('opacity','1');
}
//End Handling
//Handling Mouse Click Event
nilevalley = function(){

		if(!AdFlag){
		if (deviceapis.recognition) { //unsubscribe Event handlers
			deviceapis.recognition.UnsubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "Maps");
			deviceapis.recognition.HideVoiceHelpbar();
		}
		}
		sf.scene.hide('Maps');
		sf.scene.show('NileValley');
		sf.scene.focus('NileValley');
}
mediterranean = function(){
	
		if(!AdFlag){
		if (deviceapis.recognition) { //unsubscribe Event handlers
			deviceapis.recognition.UnsubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "Maps");
			deviceapis.recognition.HideVoiceHelpbar();
		}
		}
		sf.scene.hide('Maps');
		sf.scene.show('Mediterranean');
		sf.scene.focus('Mediterranean');
}
redsea = function(){

		if(!AdFlag){
		if (deviceapis.recognition) { //unsubscribe Event handlers
			deviceapis.recognition.UnsubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "Maps");
			deviceapis.recognition.HideVoiceHelpbar();
		}
		}
		sf.scene.hide('Maps');
		sf.scene.show('RedSea');
		sf.scene.focus('RedSea');
}
westerndesert = function(){

		if(!AdFlag){
		if (deviceapis.recognition) { //unsubscribe Event handlers
			deviceapis.recognition.UnsubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "Maps");
			deviceapis.recognition.HideVoiceHelpbar();
		}
		}
		sf.scene.hide('Maps');
		sf.scene.show('WesternDesert');
		sf.scene.focus('WesternDesert');
}
//End Handling

SceneMaps.prototype.upNavigation = function(){
	//This function handle up remote controller event & up voice command.
	switch(this.index){
		case 3:
			$('#WesternDesert').css('opacity','0.2');
			$('#NileValley').css('opacity','1');
			this.index=1;
			break;
		case 4:
			$('#RedSea').css('opacity','0.2');
			$('#Mediterranean').css('opacity','1');
			this.index=2;
			break;}
}
SceneMaps.prototype.downNavigation = function(){
	//This function handle down remote controller event & down voice command. 
	switch(this.index){
	case 1:
		$('#NileValley').css('opacity','0.2');
		$('#WesternDesert').css('opacity','1');
		this.index=3;
		break;
	case 2:
		$('#Mediterranean').css('opacity','0.2');
		$('#RedSea').css('opacity','1');
		this.index=4;
		break;}
}
SceneMaps.prototype.rightNavigation = function(){
	//This function handle right remote controller event & right voice command. 
	switch(this.index){
    case 1:
  	  $('#NileValley').css('opacity','0.2');
  	  $('#Mediterranean').css('opacity','1');
  	  this.index=2;
  	  break;
    case 3:
  	  $('#WesternDesert').css('opacity','0.2');
  	  $('#RedSea').css('opacity','1');
  	  this.index=4;
  	  break;}
}
SceneMaps.prototype.leftNavigation = function(){
	//This function handle left remote controller event & left voice command. 
	  switch(this.index){
      case 2:
   	   $('#Mediterranean').css('opacity','0.2');
   	   $('#NileValley').css('opacity','1');
   	   this.index=1;
   	   break;
      case 4:
   	   $('#RedSea').css('opacity','0.2');
   	   $('#WesternDesert').css('opacity','1');
   	   this.index=3;
   	   break;}	
}
SceneMaps.prototype.enterNavigation = function(){
	//This function handle enter remote controller event & open voice command.

		if(!AdFlag){
			if (deviceapis.recognition) { //unsubscribe Event handlers
				deviceapis.recognition.UnsubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "Maps");
				deviceapis.recognition.HideVoiceHelpbar();
			}
		}
	switch(this.index){
	case 1:
		sf.scene.hide('Maps');
		sf.scene.show('NileValley');
		sf.scene.focus('NileValley');
		break;
	case 2:
		sf.scene.hide('Maps');
		sf.scene.show('Mediterranean');
		sf.scene.focus('Mediterranean');
		break;
	case 3:
		sf.scene.hide('Maps');
		sf.scene.show('WesternDesert');
		sf.scene.focus('WesternDesert');
		break;
	case 4:
		sf.scene.hide('Maps');
		sf.scene.show('RedSea');
		sf.scene.focus('RedSea');
		break;
	}
}
SceneMaps.prototype.returnNavigation = function(){
	//This function handle return remote controller event & return voice command.
	if(!AdFlag){
	if (deviceapis.recognition) {//unsubscribe Event handlers
		deviceapis.recognition.UnsubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "History");
	}
	}
	sf.scene.hide('Maps');
	sf.scene.show('Main');
	sf.scene.focus('Main');
	sf.key.preventDefault();
}
SceneMaps.prototype.handleKeyDown = function (keyCode) {
	alert("SceneMaps.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
			switch (keyCode) {
					case sf.key.LEFT:
						alert("LEFT:"+sf.key.LEFT);
						this.leftNavigation();               		             
						break;
			
					case sf.key.RIGHT:
						alert("RIGHT:"+sf.key.RIGHT);
						this.rightNavigation();              
						break;
			
					case sf.key.UP:
						alert("UP:"+sf.key.UP);
						this.upNavigation();
						break;
			
					case sf.key.DOWN:
						alert("DOWN:"+sf.key.DOWN);
						this.downNavigation();		
						break;
			
		case sf.key.ENTER:
			alert("ENTER:"+sf.key.ENTER);
			this.enterNavigation();
			break;
			
		case sf.key.BLUE:
			alert("BLUE:"+sf.key.BLUE);
			if(EnglishFlag){
				EnglishFlag=false;
				$('#NileValleyThumbTitle').html("<p>وادى النيل</p>").removeClass('English').addClass('Arabic');
				$('#MediterraneanThumbTitle').html("<p>البحر الابيض المتوسط</p>").removeClass('English').addClass('Arabic');
				$('#RedSeaThumbTitle').html("<p>البحر الاحمر</p>").removeClass('English').addClass('Arabic');
				$('#WesternDesertThumbTitle').html("<p>الصحراء الغربية</p>").removeClass('English').addClass('Arabic');
				$('#MapsKeyHelp').sfKeyHelp({
					'blue':'English',
					'move':'تحريك',
					'enter':'دخول',
					'return':'رجوع'
				});
			}
			else{
				EnglishFlag=true;
				$('#NileValleyThumbTitle').html("<p>NileValley</p>").removeClass('Arabic').addClass('English');
				$('#MediterraneanThumbTitle').html("<p>Mediterranean</p>").removeClass('Arabic').addClass('English');
				$('#RedSeaThumbTitle').html("<p>Red Sea</p>").removeClass('Arabic').addClass('English');
				$('#WesternDesertThumbTitle').html("<p>Western Desert</p>").removeClass('Arabic').addClass('English');
				$('#MapsKeyHelp').sfKeyHelp({
					'blue':'عربى',
					'move':'Navigate',
					'enter':'Enter',
					'return':'Return'
				});
			}
			break;

			
		case sf.key.RETURN:
			alert("RETURN:"+sf.key.RETURN);
			this.returnNavigation();
			sf.key.preventDefault();
			break;
	}
}