alert('SceneMediterranean.js loaded');

function SceneMediterranean() {
	this.LocationsArray=null; //Storing Locations ID, Names (ar,en), Position(top,left).
	this.ProvincesArray=null; //Storing Provinces Information.
	 this.HighlightIndex=0;
	 this.elementId=null;
	 this.previousElementId='Mediterranean-0';
	 this.elementIndex=0;
}

SceneMediterranean.prototype.initialize = function () {
	alert("SceneMediterranean.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called

	this.LocationsArray=[];
	this.ProvincesArray=[];
	var _THIS_=this;
	
	 	$.getJSON("json/Mediterranean.json",function(json){
	 		$.each(json,function(i,item){
	 			var lo_id=item.LocationId;
	 			var lo_en=item.LocationName_en;
	 			var lo_ar=item.LocationName_ar;
	 			var lo_top=item.Top;
	 			var lo_left=item.Left;
	 			var lo_lat=item.Lat;
	 			var lo_lng=item.Lng;

	 			var oLocations={}; //Creating Locations Object
	 			oLocations.id=lo_id;
	 			oLocations.en=lo_en;
	 			oLocations.ar=lo_ar;
	 			oLocations.top=lo_top;
	 			oLocations.left=lo_left;
	 			oLocations.lat=lo_lat;
	 			oLocations.lng=lo_lng;
	 			
	 			_THIS_.LocationsArray.push(oLocations);
	 									});
	 													});
	 	
	 	$.getJSON("json/MediterraneanProvinces.json",function(json){
	 		$.each(json,function(i,item){
	 			var po_id=item.ProvinceId;
	 			var po_en=item.ProvinceName_en;
	 			var po_ar=item.ProvinceName_ar;
	 			var po_top=item.Top;
	 			var po_left=item.Left;
			 
	 			var oProvinces={}; //Creating Locations Object
	 			oProvinces.id=po_id;
	 			oProvinces.en=po_en;
	 			oProvinces.ar=po_ar;
	 			oProvinces.top=po_top;
	 			oProvinces.left=po_left;
	 			
	 			_THIS_.ProvincesArray.push(oProvinces);
	 									});
	 													});
	 	
	 	var sceneMediterranean=sf.scene.get('Mediterranean');
		//creating Div Elements of 11 locations.
	 	for (var i=0; i<7; i++){
			$('#MediterraneanLocations').append("<div id='Mediterranean-"+i+"'></div>");
			
			//Handling MouseOver Events.
			$('#Mediterranean-'+i).mouseover(function(event){
				sceneMediterranean.elementId = event.target.id;
				sceneMediterranean.elementIndex = sceneMediterranean.elementId.split('-');
				sceneMediterranean.HighlightIndex = parseInt(sceneMediterranean.elementIndex[1]);
				$('#'+sceneMediterranean.previousElementId).css('color','#000000');
				$('#'+sceneMediterranean.elementId).css('color','#3099fa')
			});
			//End of Handling
			
			//Handling Mouseout Events
			$('#Mediterranean-'+i).mouseout(function(event){
				sceneMediterranean.previousElementId = event.target.id;
			});
		    //End of handling
			
			//Handling Click Event
			$('#Mediterranean-'+i).click(function(){

			//initialize
			$('#MediterraneanTitle').text('');
			for (var i=0; i<sceneMediterranean.LocationsArray.length; i++){
				$('#Mediterranean-'+i).text('');
			}
			for (var i=0; i<sceneMediterranean.ProvincesArray.length; i++){
				$('#MediterraneanProvince'+i).text('');
				}
			sf.scene.hide('Mediterranean');			
			sf.scene.show('Location');
			sf.scene.focus('Location');
			});
	 	}
	 	//Creating Div Elements of 4 Provinces
	 	for (var i=0; i<4; i++){
			$('#MediterraneanProvinces').append("<div id='MediterraneanProvince"+i+"'></div>");
	 	}
}

SceneMediterranean.prototype.handleShow = function (data) {
	alert("SceneMediterranean.handleShow()");
	// this function will be called when the scene manager show this scene 
	var _th=this;
	//Showing Loading Icon
	$('#MediterraneanMapLoading').sfLoading('show');
	
	//Scene Key Help
	if(EnglishFlag){
		$('#MediterraneanKeyHelp').sfKeyHelp({
			'blue':'عربى',
			'leftright':'Navigate',
			'enter':'Enter',
			'return':'Return'
		});
	}
	else{
		$('#MediterraneanKeyHelp').sfKeyHelp({
			'blue':'English',
			'leftright':'تحريك',
			'enter':'اختيار',
			'return':'رجوع'
		});
	}
	//End Key Help.
	
	
	setTimeout(function(){
		//Filling HTML ELEMENTS with Locations Name & their positions.
		for (var i=0; i<_th.LocationsArray.length; i++){
			
			if(EnglishFlag){
				$('#Mediterranean-'+i).text(_th.LocationsArray[i].en);
				$('#MediterraneanTitle').text('White Mediterranean');
							}
			else{
				$('#Mediterranean-'+i).text(_th.LocationsArray[i].ar);
				$('#MediterraneanTitle').text('البحر الابيض المتوسط');
				}
			
			$('#Mediterranean-'+i).css({'position':'absolute',
			           					'top':_th.LocationsArray[i].top,
			           					'left':_th.LocationsArray[i].left,
										});
			$('#Mediterranean-'+i).addClass('LocationsName');
														} //For END
		
		//Filling HTML Provinces ELEMENTS with  Names & their positions.
		for (var i=0; i<_th.ProvincesArray.length; i++){
			
			if(EnglishFlag){
				$('#MediterraneanProvince'+i).text(_th.ProvincesArray[i].en);
							}
			else{
				$('#MediterraneanProvince'+i).text(_th.ProvincesArray[i].ar);
				}
			
			$('#MediterraneanProvince'+i).css({	'position':'absolute',
			           							'top':_th.ProvincesArray[i].top,
			           							'left':_th.ProvincesArray[i].left,
													});
			$('#MediterraneanProvince'+i).addClass('ProvincesName');
														}//For END
		
			$('#Mediterranean-'+_th.HighlightIndex).css('color','#3099fa');
			$('#MediterraneanMapLoading').sfLoading('hide');
	},100);

}

SceneMediterranean.prototype.handleHide = function () {
	alert("SceneMediterranean.handleHide()");
	// this function will be called when the scene manager hide this scene  
}

SceneMediterranean.prototype.handleFocus = function () {
	alert("SceneMediterranean.handleFocus()");
	// this function will be called when the scene manager focus this scene
}

SceneMediterranean.prototype.handleBlur = function () {
	alert("SceneMediterranean.handleBlur()");
	// this function will be called when the scene manager leftright focus to another scene from this scene
}

SceneMediterranean.prototype.handleKeyDown = function (keyCode) {
	alert("SceneMediterranean.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	
	switch (keyCode) {
		case sf.key.LEFT:
			alert("LEFT:"+sf.key.LEFT);
			if( this.HighlightIndex>0){
				$('#Mediterranean-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex--;
				$('#Mediterranean-'+this.HighlightIndex).css('color','#3099fa');
				this.previousElementId='Mediterranean-'+this.HighlightIndex;
										}
			break;	
		case sf.key.RIGHT:
			alert("RIGHT:"+sf.key.RIGHT);
			if( this.HighlightIndex<6){
				$('#Mediterranean-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex++;
				$('#Mediterranean-'+this.HighlightIndex).css('color','#3099fa');
				this.previousElementId='Mediterranean-'+this.HighlightIndex;
										}
		case sf.key.UP:
			break;
		case sf.key.DOWN:
			break;
		case sf.key.ENTER:
			alert("ENTER:"+sf.key.ENTER);

			//intialize
			$('#MediterraneanTitle').text('');
			for (var i=0; i<this.LocationsArray.length; i++){
				$('#Mediterranean-'+i).text('');
			}
			for (var i=0; i<this.ProvincesArray.length; i++){
				$('#MediterraneanProvince'+i).text('');
				}
			sf.scene.hide('Mediterranean');			
			sf.scene.show('Location');
			sf.scene.focus('Location');
			break;
			
		case sf.key.BLUE:
			alert("BLUE:"+sf.key.BLUE);
			if(EnglishFlag){
				EnglishFlag=false;
				$('#MediterraneanKeyHelp').sfKeyHelp({
					'blue':'English',
					'leftright':'تحريك',
					'enter':'اختيار',
					'return':'رجوع'
				});
				$('#MediterraneanTitle').text('البحر الابيض المتوسط');
			for (var i=0; i<this.LocationsArray.length; i++){
				$('#Mediterranean-'+i).text(this.LocationsArray[i].ar);}
			for (var i=0; i<this.ProvincesArray.length; i++){
				$('#MediterraneanProvince'+i).text(this.ProvincesArray[i].ar);}

									}
			else{
				EnglishFlag=true;
				$('#MediterraneanKeyHelp').sfKeyHelp({
					'blue':'عربى',
					'leftright':'Navigate',
					'enter':'Enter',
					'return':'Return'
				});
				$('#MediterraneanTitle').text('White Mediterranean');
				for (var i=0; i<this.LocationsArray.length; i++){
					$('#Mediterranean-'+i).text(this.LocationsArray[i].en);}
				for (var i=0; i<this.ProvincesArray.length; i++){
					$('#MediterraneanProvince'+i).text(this.ProvincesArray[i].en);}
			
			}
			break;
		case sf.key.RETURN:
			alert("RETURN:"+sf.key.RETURN);
			//intialize
			$('#MediterraneanTitle').text('');
			for (var i=0; i<this.LocationsArray.length; i++){
				$('#Mediterranean-'+i).text('');
			}
			for (var i=0; i<this.ProvincesArray.length; i++){
				$('#MediterraneanProvince'+i).text('');
				}
			sf.scene.hide('Mediterranean');
			sf.scene.show('Maps');
			sf.scene.focus('Maps');
			sf.key.preventDefault();
		
			break;
	}
}