alert('SceneNileValley.js loaded');

function SceneNileValley() {
this.LocationsArray=null; //Storing Locations ID, Names (ar,en), Position(top,left).
this.ProvincesArray=null; //Storing Provinces Information.
 this.HighlightIndex=0;
this.elementId=null;
this.previousElementId='NileValley-0';
this.elementIndex=0;
}

SceneNileValley.prototype.initialize = function () {
	alert("SceneNileValley.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called

	
	this.LocationsArray=[];
	this.ProvincesArray=[];
	var _THIS_=this;
	
	 	$.getJSON("json/NileValley.json",function(json){
	 		$.each(json,function(i,item){
	 			var lo_id=item.LocationId;
	 			var lo_en=item.LocationName_en;
	 			var lo_ar=item.LocationName_ar;
	 			var lo_top=item.Top;
	 			var lo_left=item.Left;
	 			var lo_width=item.width;
	 			var lo_lat=item.Lat;
	 			var lo_lng=item.Lng;
	 			
	 			var oLocations={}; //Creating Locations Object
	 			oLocations.id=lo_id;
	 			oLocations.en=lo_en;
	 			oLocations.ar=lo_ar;
	 			oLocations.top=lo_top;
	 			oLocations.left=lo_left;
	 			oLocations.width=lo_width;
	 			oLocations.lat=lo_lat;
	 			oLocations.lng=lo_lng;
	 			
	 			_THIS_.LocationsArray.push(oLocations);
	 									});
	 													});
	 	$.getJSON("json/NileValleyProvinces.json",function(json){
	 		$.each(json,function(i,item){
	 			var po_id=item.ProvinceId;
	 			var po_en=item.ProvinceName_en;
	 			var po_ar=item.ProvinceName_ar;
	 			var po_top=item.Top;
	 			var po_left=item.Left;
			 
	 			var oProvinces={}; //Creating Locations Object
	 			oProvinces.id=po_id;
	 			oProvinces.en=po_en;
	 			oProvinces.ar=po_ar;
	 			oProvinces.top=po_top;
	 			oProvinces.left=po_left;
	 			//oProvinces.width=po_width;
	 			
	 			_THIS_.ProvincesArray.push(oProvinces);
	 									});
	 													});
	 	
	 	var scenenilevalley=sf.scene.get('NileValley');
	 	//creating Div Elements of 11 locations.
	 	for (var i=0; i<12; i++){
			$('#NileValleyLocations').append("<div id='NileValley-"+i+"'></div>");
			
			//Handling MouseOver Events.
			$('#NileValley-'+i).mouseover(function(event){
				scenenilevalley.elementId = event.target.id;
				scenenilevalley.elementIndex = scenenilevalley.elementId.split('-');
				scenenilevalley.HighlightIndex = parseInt(scenenilevalley.elementIndex[1]);
				$('#'+scenenilevalley.previousElementId).css('color','#000000');
				$('#'+scenenilevalley.elementId).css('color','#3099fa')
			});
			//End of Handling
			//Handling Mouseout Events
			$('#NileValley-'+i).mouseout(function(event){
				scenenilevalley.previousElementId = event.target.id;
			});
		    //End of handling
			//Handling Click Event
			$('#NileValley-'+i).click(function(){

			//initialize
			$('#NileValleyTitle').text('');
			for (var i=0; i<scenenilevalley.LocationsArray.length; i++){
				$('#NileValley-'+i).text('');
			}
			for (var i=0; i<scenenilevalley.ProvincesArray.length; i++){
				$('#NileValleyProvince'+i).text('');
				}
			sf.scene.hide('NileValley');			
			sf.scene.show('Location');
			sf.scene.focus('Location');
			});
	 	}
	 	//ENd of Divs
	 	
	 	//Creating Div Elements of6 Provinces
	 	for (var i=0; i<7; i++){
			$('#NileValleyProvinces').append("<div id='NileValleyProvince"+i+"'></div>");
	 	}
	 	
	 	
}

SceneNileValley.prototype.handleShow = function () {
	alert("SceneNileValley.handleShow()");
	// this function will be called when the scene manager show this scene
	var _th=this;
	//Showing Loading Icon
	$('#NileValleyMapLoading').sfLoading('show');
	
	//Scene Key Help
	if(EnglishFlag){
		$('#NileValleyKeyHelp').sfKeyHelp({
			'blue':'عربى',
			'move':'Navigate',
			'enter':'Enter',
			'return':'Return'
		});
	}
	else{
		$('#NileValleyKeyHelp').sfKeyHelp({
			'blue':'English',
			'move':'تحريك',
			'enter':'اختيار',
			'return':'رجوع'
		});
	}
	//End Key Help
	
	setTimeout(function(){
		//Filling HTML ELEMENTS with Locations Name & their positions.
		for (var i=0; i<_th.LocationsArray.length; i++){
			if(EnglishFlag){
				$('#NileValley-'+i).text(_th.LocationsArray[i].en).removeClass('ArNileValley').addClass('En');
				$('#NileValleyTitle').text('NileValley');
				}
			else{
				$('#NileValley-'+i).text(_th.LocationsArray[i].ar).removeClass('En').addClass('ArNileValley');
				$('#NileValleyTitle').text('وادى النيل');
				}
			$('#NileValley-'+i).css({		'position':'absolute',
			           						'top':_th.LocationsArray[i].top,
			           						'left':_th.LocationsArray[i].left,
			           						'width':_th.LocationsArray[i].width,
			          					});
			$('#NileValley-'+i).addClass('LocationsName');
														} //For END
		
		//Filling HTML Provinces ELEMENTS with  Names & their positions.
		for (var i=0; i<_th.ProvincesArray.length; i++){
			
			if(EnglishFlag){
				$('#NileValleyProvince'+i).text(_th.ProvincesArray[i].en);
				}
			else{
				$('#NileValleyProvince'+i).text(_th.ProvincesArray[i].ar);
				}
			$('#NileValleyProvince'+i).css({		'position':'absolute',
			           								'top':_th.ProvincesArray[i].top,
			           								'left':_th.ProvincesArray[i].left,
			          							});
			$('#NileValleyProvince'+i).addClass('ProvincesName');
														}//For END
		
				$('#NileValley-'+_th.HighlightIndex).css('color','#3099fa');
				$('#NileValleyMapLoading').sfLoading('hide');
	},100);
	
}

SceneNileValley.prototype.handleHide = function () {
	alert("SceneNileValley.handleHide()");
	// this function will be called when the scene manager hide this scene  
}

SceneNileValley.prototype.handleFocus = function () {
	alert("SceneNileValley.handleFocus()");
	// this function will be called when the scene manager focus this scene
}

SceneNileValley.prototype.handleBlur = function () {
	alert("SceneNileValley.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneNileValley.prototype.handleKeyDown = function (keyCode) {
	alert("SceneNileValley.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	
	switch (keyCode) {
		case sf.key.LEFT:
			alert("LEFT:"+sf.key.LEFT);
					if( this.HighlightIndex>5){
						$('#NileValley-'+this.HighlightIndex).css('color','#000000');
						this.HighlightIndex-=6;
						$('#NileValley-'+this.HighlightIndex).css('color','#3099fa');
						this.previousElementId='NileValley-'+this.HighlightIndex;
												}
					break;			

		case sf.key.RIGHT:
			alert("RIGHT:"+sf.key.RIGHT);
					if( this.HighlightIndex<6){	
						  	$('#NileValley-'+this.HighlightIndex).css('color','#000000');
							this.HighlightIndex+=6;
							$('#NileValley-'+this.HighlightIndex).css('color','#3099fa'); 
							this.previousElementId='NileValley-'+this.HighlightIndex;
												}
				  break;
		
		case sf.key.UP:
			alert("UP:"+sf.key.UP);
				if( this.HighlightIndex>0){	
					$('#NileValley-'+this.HighlightIndex).css('color','#000000');
					this.HighlightIndex-=1;
					$('#NileValley-'+this.HighlightIndex).css('color','#3099fa');
					this.previousElementId='NileValley-'+this.HighlightIndex;
												}	
				break;
		
		case sf.key.DOWN:
			alert("DOWN:"+sf.key.DOWN);
			   if( this.HighlightIndex<11){
				   $('#NileValley-'+this.HighlightIndex).css('color','#000000');
				   this.HighlightIndex+=1;
				   $('#NileValley-'+this.HighlightIndex).css('color','#3099fa');
				   this.previousElementId='NileValley-'+this.HighlightIndex;
											}
			   break;			

		case sf.key.ENTER:
			alert("ENTER:"+sf.key.ENTER);

			//intialize
			$('#NileValleyTitle').text('');
			for (var i=0; i<this.LocationsArray.length; i++){
				$('#NileValley-'+i).text('');
			}
			for (var i=0; i<this.ProvincesArray.length; i++){
				$('#NileValleyProvince'+i).text('');
				}
			sf.scene.hide('NileValley');			
			sf.scene.show('Location');
			sf.scene.focus('Location');
			break;
			
		case sf.key.BLUE:
			alert("BLUE:"+sf.key.BLUE);
			if(EnglishFlag){
				EnglishFlag=false;
				$('#NileValleyKeyHelp').sfKeyHelp({
					'blue':'English',
					'move':'تحريك',
					'enter':'اختيار',
					'return':'رجوع'
				});
				$('#NileValleyTitle').text('وادى النيل');
			for (var i=0; i<this.LocationsArray.length; i++){
				$('#NileValley-'+i).text(this.LocationsArray[i].ar);
				$('#NileValley-'+i).removeClass('En').addClass('ArNileValley');}
			for (var i=0; i<this.ProvincesArray.length; i++){
				$('#NileValleyProvince'+i).text(this.ProvincesArray[i].ar);
				}
									}
			else{
				EnglishFlag=true;
				$('#NileValleyKeyHelp').sfKeyHelp({
					'blue':'عربى',
					'move':'Navigate',
					'enter':'Enter',
					'return':'Return'
				});
				$('#NileValleyTitle').text('NileValley');
				for (var i=0; i<this.LocationsArray.length; i++){
					$('#NileValley-'+i).text(this.LocationsArray[i].en);
					$('#NileValley-'+i).removeClass('ArNileValley').addClass('En');}
				for (var i=0; i<this.ProvincesArray.length; i++){
					$('#NileValleyProvince'+i).text(this.ProvincesArray[i].en);
					}
			}
			break;
		case sf.key.RETURN:
			alert("RETURN:"+sf.key.RETURN);
			//intialize
			$('#NileValleyTitle').text('');
			for (var i=0; i<this.LocationsArray.length; i++){
				$('#NileValley-'+i).text('');
			}
			for (var i=0; i<this.ProvincesArray.length; i++){
				$('#NileValleyProvince'+i).text('');
				}
			sf.scene.hide('NileValley');
			sf.scene.show('Maps');
			sf.scene.focus('Maps');
			sf.key.preventDefault();
			break;
	}
}