/**
* @file      Player.js
* @brief     This Scene is Videos Scene.
* @author    Moataz Abdallh
* @date      3 June 2013
*/

alert('ScenePlayer.js loaded');

function ScenePlayer() {
	this.index=0;
	this.previousIndex=0;
	this.imageArray=null; //used to store Images of VideoBar.
	this.page=0; //used for VideoBar Navigation
	this.idArray=['vQ1WDrbxvc8','KK5JKm8HFZs','pQcUU-g3c48','nGJ8OhqGYCs','WcsWoM3sg_4','o_hHR-fGAqQ','_tP77Ud0EME','HSBRCytZFME','dZwWUgKNeP4','AGd8r5egwDg','8w_XzxuTn0Q','c3RV4tNvH_4','ZP7Ruf5E_Uk','uCh7vZM01w8','YOqQKCiAnKg','UIyfwfikjfM','d83mn1yxCHc','xZaBZPWo11Y','T0RTrUKQM6g','53zox_K7g2c'];
	this.idIndex=0; //Index to access Streaming Links.
	this.player=null;
	this.PlayingFlag=false;
	this.PausedFlag=false;
	this.EndedFlag=false;
	this.fullscreenFlag=false;
	this.continuousFlag=false;
	this.contIdIndex=0;
	this.contPage=0;
	this.contIndex=0;
	this.currentIdIndex=0;
	this.entered=false;
	this.qualityArray=null;
	this.changeQualityFlag=false;
	this.listIndex=0;
}

ScenePlayer.prototype.initialize = function () {
	alert("ScenePlayer.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
	this.imageArray=[];
	for(var i=0;i<7;i++){
		this.imageArray[i]="images/thumb"+i+".jpg";
	}
	
	sf.service.setScreenSaver(false);
	
	//updating Frame Number
	$('#enCurrentFrame').text(1);
	$('#arCurrentFrame').text('١');

}
function onYouTubePlayerReady() {
	  alert("onYouTubePlayerReady " );
	  var _THIS_=sf.scene.get('Player');
	  var player = document.getElementById('ytplayer');
	  player.loadVideoById(_THIS_.idArray[_THIS_.currentIdIndex]);  
	  player.addEventListener("onStateChange", "onPlayerStateChange");
	  _THIS_.player=player;
	  /*
	  $('a').click(function(evt){ //prevent clicking on List Items.
			evt.preventDefault();
			evt.stopPropagation();
		});*/
	  
	  
  }
function onPlayerStateChange(state) {
	var _THIS_=sf.scene.get('Player');
	if(state==1){
		_THIS_.player.setVolume(100);
		_THIS_.EndedFlag=false;
		_THIS_.updateKeyHelp();
	}
     if(state==0){
    	 
    	 if(!_THIS_.continuousFlag){//In case the Stream is finished So disable player buttons features.
    	_THIS_.EndedFlag=true;
    	_THIS_.updateKeyHelp();
    	 }//End
    	 
    	 if(_THIS_.continuousFlag && _THIS_.contIdIndex==19){ //In case u are in cont. streaming & in the last item.
    		 _THIS_.continuousFlag=false;
    		 _THIS_.EndedFlag=true;
    	     _THIS_.updateKeyHelp(); 
    	 }//End
    	 
    	if(!_THIS_.continuousFlag && _THIS_.fullscreenFlag){ // Return to normal View if no continuous playing
    		_THIS_.normalScreen();	
    	}
    	if(_THIS_.continuousFlag && _THIS_.fullscreenFlag && _THIS_.contIdIndex==19){ // in case u are in the last video full-screen 
    		_THIS_.normalScreen();
    	}
    	if(_THIS_.continuousFlag && _THIS_.contIdIndex<19){

    		_THIS_.contIdIndex++;
    		_THIS_.player.loadVideoById(_THIS_.idArray[_THIS_.contIdIndex]);
    		
    		//Closing ChangeQuality Window
    		_THIS_.changeQualityFlag=true;
    		_THIS_.changeQuality();
    		
    		//updating Player Highlight
    		_THIS_.contIndex++;
    		if(_THIS_.contPage==0){
    			$('#RightArrow').css('display','block');
    	    	$('#LeftArrow').css('display','none');
    			$('#thumb0 img').attr('src','images/thumb0.jpg');
    			$('#thumb1 img').attr('src','images/thumb1.jpg');
    			$('#thumb2 img').attr('src','images/thumb2.jpg');
    			$('#thumb3 img').attr('src','images/thumb3.jpg');
    			//updating Frame Number
    			$('#enCurrentFrame').text(1);
    			$('#arCurrentFrame').text('١');
    		}
    		else if(_THIS_.contPage==1){
    			$('#RightArrow').css('display','block');
    	    	$('#LeftArrow').css('display','block');
    			$('#thumb0 img').attr('src','images/thumb4.jpg');
    			$('#thumb1 img').attr('src','images/thumb5.jpg');
    			$('#thumb2 img').attr('src','images/thumb6.jpg');
    			$('#thumb3 img').attr('src','images/thumb7.jpg');
    			//updating Frame Number
    			$('#enCurrentFrame').text(2);
    			$('#arCurrentFrame').text('٢');
    		}
    		else if(_THIS_.contPage==2){
    			$('#RightArrow').css('display','block');
    	    	$('#LeftArrow').css('display','block');
    	    	$('#thumb0 img').attr('src','images/thumb8.jpg');
    			$('#thumb1 img').attr('src','images/thumb9.jpg');
    			$('#thumb2 img').attr('src','images/thumb10.jpg');
    			$('#thumb3 img').attr('src','images/thumb11.jpg');
    			//updating Frame Number
    			$('#enCurrentFrame').text(3);
    			$('#arCurrentFrame').text('٣');
    		}
    		else if(_THIS_.contPage==3){
    			$('#RightArrow').css('display','block');
    	    	$('#LeftArrow').css('display','block');
    	    	$('#thumb0 img').attr('src','images/thumb12.jpg');
    			$('#thumb1 img').attr('src','images/thumb13.jpg');
    			$('#thumb2 img').attr('src','images/thumb14.jpg');
    			$('#thumb3 img').attr('src','images/thumb15.jpg');
    			//updating Frame Number
    			$('#enCurrentFrame').text(4);
    			$('#arCurrentFrame').text('٤');
    		}
    		else if(_THIS_.contPage==4){
    			$('#RightArrow').css('display','none');
    	    	$('#LeftArrow').css('display','block');
    	    	$('#thumb0 img').attr('src','images/thumb16.jpg');
    			$('#thumb1 img').attr('src','images/thumb17.jpg');
    			$('#thumb2 img').attr('src','images/thumb18.jpg');
    			$('#thumb3 img').attr('src','images/thumb19.jpg');
    			//updating Frame Number
    			$('#enCurrentFrame').text(5);
    			$('#arCurrentFrame').text('٥');
    		}
    		if(_THIS_.contIndex>3 && _THIS_.contPage==0){
    		    _THIS_.contPage++;
    	    	_THIS_.contIndex=0;
    	    	$('#RightArrow').css('display','block');
    	    	$('#LeftArrow').css('display','block');
    			$('#thumb0 img').attr('src','images/thumb4.jpg');
    			$('#thumb1 img').attr('src','images/thumb5.jpg');
    			$('#thumb2 img').attr('src','images/thumb6.jpg');
    			$('#thumb3 img').attr('src','images/thumb7.jpg');
    			//updating Frame Number
    			$('#enCurrentFrame').text(2);
    			$('#arCurrentFrame').text('٢');
    		}
    		else if(_THIS_.contIndex>3 && _THIS_.contPage==1){
    		    _THIS_.contPage++;
    	    	_THIS_.contIndex=0;
    	    	$('#RightArrow').css('display','block');
    	    	$('#LeftArrow').css('display','block');
    			$('#thumb0 img').attr('src','images/thumb8.jpg');
    			$('#thumb1 img').attr('src','images/thumb9.jpg');
    			$('#thumb2 img').attr('src','images/thumb10.jpg');
    			$('#thumb3 img').attr('src','images/thumb11.jpg');
    			//updating Frame Number
    			$('#enCurrentFrame').text(3);
    			$('#arCurrentFrame').text('٣');
    		}
    		else if(_THIS_.contIndex>3 && _THIS_.contPage==2){
    		    _THIS_.contPage++;
    	    	_THIS_.contIndex=0;
    	    	$('#RightArrow').css('display','block');
    	    	$('#LeftArrow').css('display','block');
    			$('#thumb0 img').attr('src','images/thumb12.jpg');
    			$('#thumb1 img').attr('src','images/thumb13.jpg');
    			$('#thumb2 img').attr('src','images/thumb14.jpg');
    			$('#thumb3 img').attr('src','images/thumb15.jpg');
    			//updating Frame Number
    			$('#enCurrentFrame').text(4);
    			$('#arCurrentFrame').text('٤');
    		}
    		else if(_THIS_.contIndex>3 && _THIS_.contPage==3){
    		    _THIS_.contPage++;
    	    	_THIS_.contIndex=0;
    	    	$('#RightArrow').css('display','none');
    	    	$('#LeftArrow').css('display','block');
    			$('#thumb0 img').attr('src','images/thumb16.jpg');
    			$('#thumb1 img').attr('src','images/thumb17.jpg');
    			$('#thumb2 img').attr('src','images/thumb18.jpg');
    			$('#thumb3 img').attr('src','images/thumb19.jpg');
    			//updating Frame Number
    			$('#enCurrentFrame').text(5);
    			$('#arCurrentFrame').text('٥');
    		}
    		if(_THIS_.contIndex>3){
    			_THIS_.contIndex=3;
    		}

    		if(_THIS_.contIndex<4 && _THIS_.contPage<5){
    			alert("Highlight"+_THIS_.contIndex);
    				$('#PlayerHighlight0').css('display','none');
    				$('#PlayerHighlight1').css('display','none');
    				$('#PlayerHighlight2').css('display','none');
    				$('#PlayerHighlight3').css('display','none');
    				$('#PlayerHighlight'+_THIS_.contIndex).css('display','block');
    		}
    		_THIS_.index=_THIS_.contIndex;
    		_THIS_.page=_THIS_.contPage;
    		_THIS_.idIndex=_THIS_.contIdIndex;
    		
    		
    	}
    }
}
ScenePlayer.prototype.handleShow = function (data) {
	alert("ScenePlayer.handleShow()");
	// this function will be called when the scene manager show this scene 
	 // The video to load.
	this.entered = true;
	if(EnglishFlag){
		$('#PlayerKeyHelp').sfKeyHelp({
			'blue':'عربى',
			'yellow':'FullScreen',
			'green':'Continuous Play',
			'red':'Quality',
			'leftright':'Navigate',
			'enter':'Play Video',
			'play':'',
			'pause':'',
			'number':'',
			'return':'Return'
		});
	}
	else{
		$('#PlayerKeyHelp').sfKeyHelp({
			'blue':'English',
			'yellow':'تكبير شاشة العرض',
			'green':'تشغيل مستمر',
			'red':'الجودة',
			'leftright':'تحريك',
			'enter':'اختيار',
			'play':'',
			'pause':'',
			'number':'',
			'return':'رجوع'
		});
	}
	sf.service.setVolumeControl(true);
	if(!AdFlag){
	if (deviceapis.recognition.IsRecognitionSupported()) {
		deviceapis.recognition.SubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "Player", handlePlayerRecognitionEvent);
	} 
	else {
		alert("ERROR: Voice recognition not supported");
	}
	
	var playerHelpbar = {
			helpbarType: "HELPBAR_TYPE_VOICE_CUSTOMIZE",
			bKeepCurrentInfo: "false",
			helpbarItemsList: [
				{ itemText: "Left", commandList: [{command: "Left"}]},
				{ itemText: "Right", commandList: [{command: "Right"}]},
				{ itemText: "Open", commandList: [{command: "Open"}]},
				{ itemText: "Pause", commandList: [{command: "Pause"}]},
				{ itemText: "Play", commandList: [{command: "Play"}]},
				{ itemText: "Return", commandList: [{command: "Return"}]}
				]
	};
	deviceapis.recognition.SetVoiceHelpbarInfo(JSON.stringify(playerHelpbar));
	}
  }

//Handling Voice commands
handlePlayerRecognitionEvent= function (evt) {
	var _THIS_=sf.scene.get('Player');
	switch (evt.eventtype) {
		case "EVENT_VOICE_BEGIN_MONITOR":
		case "EVENT_VOICE_BTSOUND_START":
			break;
		case "EVENT_VOICE_RECOG_RESULT":
			switch (evt.result.toLowerCase()) {
			case "left": _THIS_.leftNavigation(); break;
			case "right": _THIS_.rightNavigation(); break;
			case "open": _THIS_.enterNavigation(); break;
			case "play":
				_THIS_.PlayingFlag=true;
				_THIS_.PausedFlag=false;
				_THIS_.player.playVideo();
				_THIS_.EndedFlag=false;
				_THIS_.updateKeyHelp();
				break;
			case "pause": 
				_THIS_.PlayingFlag=false;
				_THIS_.PausedFlag=true;
				_THIS_.player.pauseVideo();
				break;
			case "return": _THIS_.returnNavigation(); break;
		}
			break;
	}
}
//END Voice handling
//Handling Voice commands of fullscreen
handlePlayerFullScreenRecognitionEvent= function (evt) {
	var _THIS_=sf.scene.get('Player');
	switch (evt.eventtype) {
		case "EVENT_VOICE_BEGIN_MONITOR":
		case "EVENT_VOICE_BTSOUND_START":
			break;
		case "EVENT_VOICE_RECOG_RESULT":
			switch (evt.result.toLowerCase()) {
			case "continuous": _THIS_.continuousPlay(); break;
			case "play":
				_THIS_.PlayingFlag=true;
				_THIS_.PausedFlag=false;
				_THIS_.player.playVideo();
				break;
			case "pause": 
				_THIS_.PlayingFlag=false;
				_THIS_.PausedFlag=true;
				_THIS_.player.pauseVideo();
				break;
			case "return": _THIS_.returnNavigation(); break;
		}
			break;
	}
}
//END Voice handling
ScenePlayer.prototype.handleHide = function () {
	alert("ScenePlayer.handleHide()");
	// this function will be called when the scene manager hide this scene  
}

ScenePlayer.prototype.handleFocus = function () {
	alert("ScenePlayer.handleFocus()");
	// this function will be called when the scene manager focus this scene
}


ScenePlayer.prototype.handleBlur = function () {
	alert("ScenePlayer.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}


thumbHighlight0 = function(){
	var scene=sf.scene.get('Player');
	
	if(scene.changeQualityFlag==true){//in case quality window is opened, Close It
		scene.changeQuality();
	}
	scene.index=0;
	if(scene.page==0){
	scene.idIndex=0;
	}
	else if(scene.page==1){
		scene.idIndex=4;
	}
	else if(scene.page==2){
		scene.idIndex=8;
	}
	else if(scene.page==3){
		scene.idIndex=12;
	}
	else if(scene.page==4){
		scene.idIndex=16;
	}
	$('#PlayerHighlight1').css('display','none');
	$('#PlayerHighlight2').css('display','none');
	$('#PlayerHighlight3').css('display','none');
	$('#PlayerHighlight0').css('display','block');
	 scene.player.loadVideoById(scene.idArray[scene.idIndex]);
	 scene.currentIdIndex=scene.idIndex;
	 scene.contIdIndex=scene.idIndex;
	 scene.contPage=scene.page;
	 scene.contIndex=scene.index;

}
thumbHighlight1 = function(){
	var scene=sf.scene.get('Player');
	
	if(scene.changeQualityFlag==true){//in case quality window is opened
		scene.changeQuality();
	}
	scene.index=1;
	if(scene.page==0){
		scene.idIndex=1;
		}
		else if(scene.page==1){
			scene.idIndex=5;
		}
		else if(scene.page==2){
			scene.idIndex=9;
		}
		else if(scene.page==3){
			scene.idIndex=13;
		}
		else if(scene.page==4){
			scene.idIndex=17;
		}
	$('#PlayerHighlight0').css('display','none');
	$('#PlayerHighlight2').css('display','none');
	$('#PlayerHighlight3').css('display','none');
	$('#PlayerHighlight1').css('display','block');
	scene.player.loadVideoById(scene.idArray[scene.idIndex]);
	 scene.currentIdIndex=scene.idIndex;
	 scene.contIdIndex=scene.idIndex;
	 scene.contPage=scene.page;
	 scene.contIndex=scene.index;
}
thumbHighlight2 = function(){
	var scene=sf.scene.get('Player');
	
	if(scene.changeQualityFlag==true){//in case quality window is opened
		scene.changeQuality();
	}
	scene.index=2;
	if(scene.page==0){
		scene.idIndex=2;
		}
		else if(scene.page==1){
			scene.idIndex=6;
		}
		else if(scene.page==2){
			scene.idIndex=10;
		}
		else if(scene.page==3){
			scene.idIndex=14;
		}
		else if(scene.page==4){
			scene.idIndex=18;
		}
	$('#PlayerHighlight1').css('display','none');
	$('#PlayerHighlight0').css('display','none');
	$('#PlayerHighlight3').css('display','none');
	$('#PlayerHighlight2').css('display','block');
	scene.player.loadVideoById(scene.idArray[scene.idIndex]);
	 scene.currentIdIndex=scene.idIndex;
	 scene.contIdIndex=scene.idIndex;
	 scene.contPage=scene.page;
	 scene.contIndex=scene.index;
}
thumbHighlight3 = function(){
	var scene=sf.scene.get('Player');
	
	if(scene.changeQualityFlag==true){//in case quality window is opened
		scene.changeQuality();
	}
	scene.index=3;
	if(scene.page==0){
		scene.idIndex=3;
		}
		else if(scene.page==1){
			scene.idIndex=7;
		}
		else if(scene.page==2){
			scene.idIndex=11;
		}
		else if(scene.page==3){
			scene.idIndex=15;
		}
		else if(scene.page==4){
			scene.idIndex=19;
		}
	$('#PlayerHighlight1').css('display','none');
	$('#PlayerHighlight2').css('display','none');
	$('#PlayerHighlight0').css('display','none');
	$('#PlayerHighlight3').css('display','block');
	scene.player.loadVideoById(scene.idArray[scene.idIndex]);
	 scene.currentIdIndex=scene.idIndex;
	 scene.contIdIndex=scene.idIndex;
	 scene.contPage=scene.page;
	 scene.contIndex=scene.index;
}
leftArrow = function(){
	var scene=sf.scene.get('Player');
	
	if(scene.changeQualityFlag==true){//in case quality window is opened
		scene.changeQuality();
	}
	
	scene.index=3;
	
	$('#PlayerHighlight1').css('display','none');
	$('#PlayerHighlight2').css('display','none');
	$('#PlayerHighlight0').css('display','none');
	$('#PlayerHighlight3').css('display','block');
	if(scene.page==1){
		scene.page=0;
		scene.idIndex=3;
		$('#LeftArrow').css('display','none');
		$('#RightArrow').css('display','block');
		$('#thumb0 img').attr('src','images/thumb0.jpg');
		$('#thumb1 img').attr('src','images/thumb1.jpg');
		$('#thumb2 img').attr('src','images/thumb2.jpg');
		$('#thumb3 img').attr('src','images/thumb3.jpg');
		//updating Frame Number
		$('#enCurrentFrame').text(1);
		$('#arCurrentFrame').text('١');
	}
	else if(scene.page==2){
		scene.page=1;
		scene.idIndex=7;
		$('#LeftArrow').css('display','block');
		$('#RightArrow').css('display','block');
		$('#thumb0 img').attr('src','images/thumb4.jpg');
		$('#thumb1 img').attr('src','images/thumb5.jpg');
		$('#thumb2 img').attr('src','images/thumb6.jpg');
		$('#thumb3 img').attr('src','images/thumb7.jpg');
		//updating Frame Number
		$('#enCurrentFrame').text(2);
		$('#arCurrentFrame').text('٢');
	}
	else if(scene.page==3){
		scene.page=2;
		scene.idIndex=11;
		$('#LeftArrow').css('display','block');
		$('#RightArrow').css('display','block');
		$('#thumb0 img').attr('src','images/thumb8.jpg');
		$('#thumb1 img').attr('src','images/thumb9.jpg');
		$('#thumb2 img').attr('src','images/thumb10.jpg');
		$('#thumb3 img').attr('src','images/thumb11.jpg');
		//updating Frame Number
		$('#enCurrentFrame').text(3);
		$('#arCurrentFrame').text('٣');
	}
	else if(scene.page==4){
		scene.page=3;
		scene.idIndex=15;
		$('#LeftArrow').css('display','block');
		$('#RightArrow').css('display','block');
		$('#thumb0 img').attr('src','images/thumb12.jpg');
		$('#thumb1 img').attr('src','images/thumb13.jpg');
		$('#thumb2 img').attr('src','images/thumb14.jpg');
		$('#thumb3 img').attr('src','images/thumb15.jpg');
		//updating Frame Number
		$('#enCurrentFrame').text(4);
		$('#arCurrentFrame').text('٤');
	}
}
rightArrow = function(){
	var scene=sf.scene.get('Player');
	if(scene.changeQualityFlag==true){//in case quality window is opened
		scene.changeQuality();
	}
	scene.index=0;
	$('#PlayerHighlight1').css('display','none');
	$('#PlayerHighlight2').css('display','none');
	$('#PlayerHighlight3').css('display','none');
	$('#PlayerHighlight0').css('display','block');
	if(scene.page==0){
		scene.page=1;
		scene.idIndex=4;
		$('#RightArrow').css('display','block');
		$('#LeftArrow').css('display','block');
		$('#thumb0 img').attr('src','images/thumb4.jpg');
		$('#thumb1 img').attr('src','images/thumb5.jpg');
		$('#thumb2 img').attr('src','images/thumb6.jpg');
		$('#thumb3 img').attr('src','images/thumb7.jpg');
		//updating Frame Number
		$('#enCurrentFrame').text(2);
		$('#arCurrentFrame').text('٢');
	}
	else if(scene.page==1){
		scene.page=2;
		scene.idIndex=8;
		$('#RightArrow').css('display','block');
		$('#LeftArrow').css('display','block');
		$('#thumb0 img').attr('src','images/thumb8.jpg');
		$('#thumb1 img').attr('src','images/thumb9.jpg');
		$('#thumb2 img').attr('src','images/thumb10.jpg');
		$('#thumb3 img').attr('src','images/thumb11.jpg');
		//updating Frame Number
		$('#enCurrentFrame').text(3);
		$('#arCurrentFrame').text('٣');
	}
	else if(scene.page==2){
		scene.page=3;
		scene.idIndex=12;
		$('#RightArrow').css('display','block');
		$('#LeftArrow').css('display','block');
		$('#thumb0 img').attr('src','images/thumb12.jpg');
		$('#thumb1 img').attr('src','images/thumb13.jpg');
		$('#thumb2 img').attr('src','images/thumb14.jpg');
		$('#thumb3 img').attr('src','images/thumb15.jpg');
		//updating Frame Number
		$('#enCurrentFrame').text(4);
		$('#arCurrentFrame').text('٤');
	}
	else if(scene.page==3){
		scene.page=4;
		scene.idIndex=16;
		$('#RightArrow').css('display','none');
		$('#LeftArrow').css('display','block');
		$('#thumb0 img').attr('src','images/thumb16.jpg');
		$('#thumb1 img').attr('src','images/thumb17.jpg');
		$('#thumb2 img').attr('src','images/thumb18.jpg');
		$('#thumb3 img').attr('src','images/thumb19.jpg');
		//updating Frame Number
		$('#enCurrentFrame').text(5);
		$('#arCurrentFrame').text('٥');
	}
	
}

ScenePlayer.prototype.leftNavigation = function(){
	//This function handle left remote controller event & left voice command. 
	if(!this.changeQualityFlag){
	this.index--;
	this.previousIndex=this.index+1;
	if(this.index<0&&this.page==1){
		this.page--;
		this.index=3;
		$('#LeftArrow').css('display','none');
    	$('#RightArrow').css('display','block');
		$('#thumb0 img').attr('src','images/thumb0.jpg');
		$('#thumb1 img').attr('src','images/thumb1.jpg');
		$('#thumb2 img').attr('src','images/thumb2.jpg');
		$('#thumb3 img').attr('src','images/thumb3.jpg');
		//updating Frame Number
		$('#enCurrentFrame').text(1);
		$('#arCurrentFrame').text('١');
	}
	else if(this.index<0&&this.page==2){
		this.page--;
		this.index=3;
		$('#LeftArrow').css('display','block');
    	$('#RightArrow').css('display','block');
		$('#thumb0 img').attr('src','images/thumb4.jpg');
		$('#thumb1 img').attr('src','images/thumb5.jpg');
		$('#thumb2 img').attr('src','images/thumb6.jpg');
		$('#thumb3 img').attr('src','images/thumb7.jpg');
		//updating Frame Number
		$('#enCurrentFrame').text(2);
		$('#arCurrentFrame').text('٢');
	}
	else if(this.index<0&&this.page==3){
		this.page--;
		this.index=3;
		$('#LeftArrow').css('display','block');
    	$('#RightArrow').css('display','block');
		$('#thumb0 img').attr('src','images/thumb8.jpg');
		$('#thumb1 img').attr('src','images/thumb9.jpg');
		$('#thumb2 img').attr('src','images/thumb10.jpg');
		$('#thumb3 img').attr('src','images/thumb11.jpg');
		//updating Frame Number
		$('#enCurrentFrame').text(3);
		$('#arCurrentFrame').text('٣');
	}
	else if(this.index<0&&this.page==4){
		this.page--;
		this.index=3;
		$('#LeftArrow').css('display','block');
    	$('#RightArrow').css('display','block');
		$('#thumb0 img').attr('src','images/thumb12.jpg');
		$('#thumb1 img').attr('src','images/thumb13.jpg');
		$('#thumb2 img').attr('src','images/thumb14.jpg');
		$('#thumb3 img').attr('src','images/thumb15.jpg');
		//updating Frame Number
		$('#enCurrentFrame').text(4);
		$('#arCurrentFrame').text('٤');
	}
	
	if(this.index<0){
		this.index=0;
		this.previousIndex=this.index+1;
	}
	if(this.index>=0&&this.page>=0){
		$('#PlayerHighlight'+this.previousIndex).css('display','none');
		$('#PlayerHighlight'+this.index).css('display','block');
}
	if(this.idIndex>0){
		this.idIndex--;
	}
}
}
ScenePlayer.prototype.rightNavigation = function(){
	//This function handle right remote controller event & right voice command. 
	if(!this.changeQualityFlag){
	this.index++;
	this.previousIndex=this.index-1;
	if(this.index>3&&this.page==0){
	    this.page++;
    	this.index=0;
    	$('#RightArrow').css('display','block');
    	$('#LeftArrow').css('display','block');
		$('#thumb0 img').attr('src','images/thumb4.jpg');
		$('#thumb1 img').attr('src','images/thumb5.jpg');
		$('#thumb2 img').attr('src','images/thumb6.jpg');
		$('#thumb3 img').attr('src','images/thumb7.jpg');
		//updating Frame Number
		$('#enCurrentFrame').text(2);
		$('#arCurrentFrame').text('٢');
	}
	else if(this.index>3&&this.page==1){
	    this.page++;
    	this.index=0;
    	$('#RightArrow').css('display','block');
    	$('#LeftArrow').css('display','block');
		$('#thumb0 img').attr('src','images/thumb8.jpg');
		$('#thumb1 img').attr('src','images/thumb9.jpg');
		$('#thumb2 img').attr('src','images/thumb10.jpg');
		$('#thumb3 img').attr('src','images/thumb11.jpg');
		//updating Frame Number
		$('#enCurrentFrame').text(3);
		$('#arCurrentFrame').text('٣');
	}
	else if(this.index>3&&this.page==2){
	    this.page++;
    	this.index=0;
    	$('#RightArrow').css('display','block');
    	$('#LeftArrow').css('display','block');
		$('#thumb0 img').attr('src','images/thumb12.jpg');
		$('#thumb1 img').attr('src','images/thumb13.jpg');
		$('#thumb2 img').attr('src','images/thumb14.jpg');
		$('#thumb3 img').attr('src','images/thumb15.jpg');
		//updating Frame Number
		$('#enCurrentFrame').text(4);
		$('#arCurrentFrame').text('٤');
	}
	else if(this.index>3&&this.page==3){
	    this.page++;
    	this.index=0;
    	$('#RightArrow').css('display','none');
    	$('#LeftArrow').css('display','block');
		$('#thumb0 img').attr('src','images/thumb16.jpg');
		$('#thumb1 img').attr('src','images/thumb17.jpg');
		$('#thumb2 img').attr('src','images/thumb18.jpg');
		$('#thumb3 img').attr('src','images/thumb19.jpg');
		//updating Frame Number
		$('#enCurrentFrame').text(5);
		$('#arCurrentFrame').text('٥');
	}
	if(this.index>3){
		this.index=3;
		this.previousIndex=this.index-1;
	}
	if(this.index<4&&this.page<5){
			$('#PlayerHighlight'+this.previousIndex).css('display','none');
			$('#PlayerHighlight'+this.index).css('display','block');
	}
	if(this.idIndex<19){
		this.idIndex++;
	}
	
}
}
ScenePlayer.prototype.updateKeyHelp = function(){
	if(this.continuousFlag){ //in case u are in continuous state
		if(EnglishFlag){ //in case u are in english state.
			if(this.fullscreenFlag){ //in case u are in fullscreen state.
				$('#PlayerKeyHelp').sfKeyHelp({
					'blue':'عربى',
					'green':'Single Play',
					'play':'',
					'pause':'',
					'number':'',
					'return':'Return'
				});
			
			}
			else{ //u are in normalScreen state.
				if(!this.EndedFlag){
					//HandlingChange Quality Flag.
				if(!this.changeQualityFlag){ 
				$('#PlayerKeyHelp').sfKeyHelp({
					'blue':'عربى',
					'yellow':'FullScreen',
					'green':'Single Play',
					'red':'Quality',
					'leftright':'Navigate',
					'enter':'Play Video',
					'play':'',
					'pause':'',
					'number':'',
					'return':'Return'
				});
			
			}
				else{
					$('#PlayerKeyHelp').sfKeyHelp({
						'blue':'عربى',
						'yellow':'FullScreen',
						'green':'Single Play',
						'red':'Close',
						'updown':'Navigate',
						'enter':'Play Video',
						'play':'',
						'pause':'',
						'number':'',
						'return':'Return'
					});
				}
				//End Handling.
				}
				
				else{ //in case of EndedFlag is Fired.
					$('#PlayerKeyHelp').sfKeyHelp({
						'blue':'عربى',
						'leftright':'Navigate',
						'enter':'Play Video',
						'play':'',
						'pause':'',
						'return':'Return'
					});
					// releasing quality control list items.
					this.changeQualityFlag=false;
					$('#enQualityControl').css('display','none');
					$('#arQualityControl').css('display','none');
					$('#qualityLevels').sfList('clear');
					$('#PlayerHighlight'+this.index).css('display','block');
				}
				//End
			} //End of Normal-Screen mode
		} //End of EnglishFlag firing.
		
		else{ //in case u are in arabic state.
			if(this.fullscreenFlag){
				$('#PlayerKeyHelp').sfKeyHelp({
					'blue':'English',
					'green':'تشغيل منفصل',
					'play':'',
					'pause':'',
					'number':'',
					'return':'رجوع'
				});
				
			}
			else{ //in case of normal-screen mode.
				if(!this.EndedFlag){
					//Handling ChangeQuality Flag
				if(!this.changeQualityFlag){ 
				$('#PlayerKeyHelp').sfKeyHelp({
					'blue':'English',
					'yellow':'تكبير شاشة العرض',
					'green':'تشغيل منفصل',
					'red':'الجودة',
					'leftright':'تحريك',
					'enter':'اختيار',
					'play':'',
					'pause':'',
					'number':'',
					'return':'رجوع'
				});
				
			}
			else{
					$('#PlayerKeyHelp').sfKeyHelp({
						'blue':'English',
						'yellow':'تكبير شاشة العرض',
						'green':'تشغيل منفصل',
						'red':'إغلاق',
						'updown':'تحريك',
						'enter':'اختيار',
						'play':'',
						'pause':'',
						'number':'',
						'return':'رجوع'
					});
				}
				//End Handling.
				}
				else{ //Handling EndedFlag is fired
					$('#PlayerKeyHelp').sfKeyHelp({
						'blue':'عربى',
						'leftright':'Navigate',
						'enter':'Play Video',
						'play':'',
						'pause':'',
						'return':'Return'
					});
					// releasing quality control list items.
					this.changeQualityFlag=false;
					$('#enQualityControl').css('display','none');
					$('#arQualityControl').css('display','none');
					$('#qualityLevels').sfList('clear');
					$('#PlayerHighlight'+this.index).css('display','block');
				}
				//End of EndedFlag Handling.
			}
		}
	}
	
	//in case u are in single play state.
	else{ 
		if(EnglishFlag){
			if(this.fullscreenFlag){
				$('#PlayerKeyHelp').sfKeyHelp({
					'blue':'عربى',
					'green':'Continuous Play',
					'play':'',
					'pause':'',
					'number':'',
					'return':'Return'
				});
			
			}
			else{
				if(!this.EndedFlag){
					//Handling ChangeQuality Flag
				if(!this.changeQualityFlag){
				$('#PlayerKeyHelp').sfKeyHelp({
					'blue':'عربى',
					'yellow':'FullScreen',
					'green':'Continuous Play',
					'red':'Quality',
					'leftright':'Navigate',
					'enter':'Play Video',
					'play':'',
					'pause':'',
					'number':'',
					'return':'Return'
				});
			}				
				else{
					$('#PlayerKeyHelp').sfKeyHelp({
						'blue':'عربى',
						'yellow':'FullScreen',
						'green':'Continuous Play',
						'red':'Close',
						'updown':'Navigate',
						'enter':'Play Video',
						'play':'',
						'pause':'',
						'number':'',
						'return':'Return'
					});
				}
				//End Handling
				}
					else{ //in case of EndedFlag is Fired.
						$('#PlayerKeyHelp').sfKeyHelp({
							'blue':'عربى',
							'leftright':'Navigate',
							'enter':'Play Video',
							'play':'',
							'pause':'',
							'return':'Return'
						});
						// releasing quality control list items.
						this.changeQualityFlag=false;
						$('#enQualityControl').css('display','none');
						$('#arQualityControl').css('display','none');
						$('#qualityLevels').sfList('clear');
						$('#PlayerHighlight'+this.index).css('display','block');
					}
				}
			}

		
		//In case Arabic Flag is Fired.
		else{
			if(this.fullscreenFlag){
				$('#PlayerKeyHelp').sfKeyHelp({
					'blue':'English',
					'green':'تشغيل مستمر',
					'play':'',
					'pause':'',
					'number':'',
					'return':'رجوع'
				});
				
			}
			else{
				if(!this.EndedFlag){
					
					//Handling ChangeQuality Flag.
				if(!this.changeQualityFlag){
				$('#PlayerKeyHelp').sfKeyHelp({
					'blue':'English',
					'yellow':'تكبير شاشة العرض',
					'green':'تشغيل مستمر',
					'red':'الجودة',
					'leftright':'تحريك',
					'enter':'اختيار',
					'play':'',
					'pause':'',
					'number':'',
					'return':'رجوع'
				});
					}
				else{
					$('#PlayerKeyHelp').sfKeyHelp({
						'blue':'English',
						'yellow':'تكبير شاشة العرض',
						'green':'تشغيل مستمر',
						'red':'إغلاق',
						'updown':'تحريك',
						'enter':'اختيار',
						'play':'',
						'pause':'',
						'number':'',
						'return':'رجوع'
					});
					
				}
				//Handling END.
				}
				else{ //EndedFlag is Fired
					$('#PlayerKeyHelp').sfKeyHelp({
						'blue':'English',
						'leftright':'تحريك',
						'enter':'اختيار',
						'play':'',
						'pause':'',
						'return':'رجوع'
					});
					// releasing quality control list items.
					this.changeQualityFlag=false;
					$('#enQualityControl').css('display','none');
					$('#arQualityControl').css('display','none');
					$('#qualityLevels').sfList('clear');
					$('#PlayerHighlight'+this.index).css('display','block');
				}
			}
		}
	}
}
ScenePlayer.prototype.fullScreen = function(){
	//This function handle yellow remote controller event & fullscreen voice command.
	if(!this.fullscreenFlag){
		this.fullscreenFlag=true;
		
		$("#playerNavigation").css('display','none');
		$("#playerContainer").removeClass("small").addClass("large");
		$("#playerSubContainer").removeClass("small").addClass("large");
		var player = document.getElementById('ytplayer');
		player.setPlaybackQuality('hd720');
			
		player.style.padding=0;
		player.width=1280;
		player.height=676;

		this.updateKeyHelp();
		if(!AdFlag){
		if (deviceapis.recognition.IsRecognitionSupported()) {
			deviceapis.recognition.SubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "PlayerFullScreen", handlePlayerFullScreenRecognitionEvent);
		} 
		else {
			alert("ERROR: Voice recognition not supported");
		}
		
		var playerFullScreenHelpbar = {
				helpbarType: "HELPBAR_TYPE_VOICE_CUSTOMIZE",
				bKeepCurrentInfo: "false",
				helpbarItemsList: [
					{ itemText: "Continuous", commandList: [{command: "Continuous"}]},
					{ itemText: "Play", commandList: [{command: "Play"}]},
					{ itemText: "Pause", commandList: [{command: "Pause"}]},
					{ itemText: "Return", commandList: [{command: "Return"}]}
					]
		};
		deviceapis.recognition.SetVoiceHelpbarInfo(JSON.stringify(playerFullScreenHelpbar));
		}
	}
}
ScenePlayer.prototype.continuousPlay = function(){
	//This function handle Green remote controller event & Continuous voice command.
	if(!this.continuousFlag){
		this.continuousFlag=true;
	}
	else{
		this.continuousFlag=false;
	}
	this.updateKeyHelp();
}
ScenePlayer.prototype.normalScreen = function(){
	this.fullscreenFlag=false;

	$("#playerContainer").removeClass("large").addClass("small");
	$("#playerSubContainer").removeClass("large").addClass("small");
	$("#playerNavigation").css('display','block');
	var player = document.getElementById('ytplayer');
	player.setPlaybackQuality('default');
		
	player.style.paddingTop=18;
	player.style.paddingLeft=240;
	player.width=808;
	player.height=435;
	
	this.updateKeyHelp();
	if(!AdFlag){
	
	if (deviceapis.recognition) {//unsubscribe Event handlers of Full Screen
		deviceapis.recognition.UnsubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "PlayerFullScreen");
	}
	if (deviceapis.recognition.IsRecognitionSupported()) {//subscribe Event handlers of small screen
		deviceapis.recognition.SubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "Player", handlePlayerRecognitionEvent);
	}
	var playerHelpbar = {
			helpbarType: "HELPBAR_TYPE_VOICE_CUSTOMIZE",
			bKeepCurrentInfo: "false",
			helpbarItemsList: [
			   				{ itemText: "Left", commandList: [{command: "Left"}]},
							{ itemText: "Right", commandList: [{command: "Right"}]},
							{ itemText: "Open", commandList: [{command: "Open"}]},
							{ itemText: "Pause", commandList: [{command: "Pause"}]},
							{ itemText: "Play", commandList: [{command: "Play"}]},
							{ itemText: "Return", commandList: [{command: "Return"}]}
							]
	};
	deviceapis.recognition.SetVoiceHelpbarInfo(JSON.stringify(playerHelpbar));
	}
}
ScenePlayer.prototype.enterNavigation = function(){
	//This function handle enter remote controller event & enter voice command. 
	
		if(!this.changeQualityFlag){ //In case ChangeQuality Window is not opened.
		this.PlayingFlag=true;
		this.PausedFlag=false;
		this.player.loadVideoById(this.idArray[this.idIndex]);
		this.player.setPlaybackQuality('default');
		this.EndedFlag=false;
		this.updateKeyHelp();
		this.currentIdIndex=this.idIndex; //setting the current playing index.
		this.contIdIndex=this.idIndex; //setting the cont. Id by the Id of the currently played index. 
		this.contPage=this.page; //setting the contpage to currently frame page.
		this.contIndex=this.index;
		}
		
		else{ // in case u are in quality control window
			this.listIndex=$('#qualityLevels').sfList('getIndex');
			this.player.setPlaybackQuality(this.qualityArray[this.listIndex]);
		}
	
}
ScenePlayer.prototype.seeking = function(percentage){
	if(!this.EndedFlag){
	var duration = this.player.getDuration();
	var time = duration*percentage;
	this.player.seekTo(time,true);
	var text=percentage*100+' %';
	$('#PlayerKeyHelp').sfKeyHelp('showNotice',{
		text:text,
		timeout:800
	});
	}
}
ScenePlayer.prototype.changeQuality = function(){
	
	if(!this.changeQualityFlag){ // showing quality control list items.
		this.changeQualityFlag=true;
		// Remove focus from frame navigation pane.
		$('#PlayerHighlight0').css('display','none');
		$('#PlayerHighlight1').css('display','none');
		$('#PlayerHighlight2').css('display','none');
		$('#PlayerHighlight3').css('display','none');
		this.updateKeyHelp();
		
		this.qualityArray=this.player.getAvailableQualityLevels();
		
	$('#qualityLevels').sfList({
		data:this.qualityArray.slice(0,this.qualityArray.length-1),
		itemsPerPage:6
	});
	$('#qualityLevels').sfList('focus');
	
	$('.sf-ui-list-item div').click(function(evt){ //prevent clicking on List Items.
		evt.preventDefault();
		evt.stopPropagation();
	});
	
	if(EnglishFlag){
		$('#arQualityControl').css('display','none');
		$('#enQualityControl').css('display','block');
	}
	else{
		$('#enQualityControl').css('display','none');
		$('#arQualityControl').css('display','block');
	}
	}
	else{ // releasing quality control list items.
		this.changeQualityFlag=false;
		this.updateKeyHelp();
		$('#enQualityControl').css('display','none');
		$('#arQualityControl').css('display','none');
		$('#qualityLevels').sfList('clear');
		$('#PlayerHighlight'+this.index).css('display','block');
	}
}
ScenePlayer.prototype.returnNavigation = function(){
	//This function handle return remote controller event & return voice command. 
	
	if(this.fullscreenFlag){ //in case u are in full-screen mode.
		this.normalScreen();
	}
	else{
		if(!AdFlag){
	if (deviceapis.recognition) {//unsubscribe Event handlers
		deviceapis.recognition.UnsubscribeExEvent(deviceapis.recognition.PL_RECOGNITION_TYPE_VOICE, "Player");
	}
	}
	
	if(this.PlayingFlag){
	this.player.stopVideo();
	}
	//Intialization
	this.index=0;
	this.previousIndex=0;
	this.page=0; //used for VideoBar Navigation
	this.idIndex=0; //Index to access Streaming Links.
	this.continuousFlag=false;
	this.contIdIndex=0;
	this.contPage=0;
	this.contIndex=0;
	this.currentIdIndex=0;
	this.entered=false;
	this.changeQualityFlag=false;
	this.EndedFlag=false;
	this.listIndex=0;
	this.updateKeyHelp();
	$('#RightArrow').css('display','block');
	$('#LeftArrow').css('display','none');
	$('#thumb0 img').attr('src','images/thumb0.jpg');
	$('#thumb1 img').attr('src','images/thumb1.jpg');
	$('#thumb2 img').attr('src','images/thumb2.jpg');
	$('#thumb3 img').attr('src','images/thumb3.jpg');
	//updating Frame Number
	$('#enCurrentFrame').text(1);
	$('#arCurrentFrame').text('١');
	$('#PlayerHighlight0').css('display','block');
	$('#PlayerHighlight1').css('display','none');
	$('#PlayerHighlight2').css('display','none');
	$('#PlayerHighlight3').css('display','none');
	$('#enQualityControl').css('display','none');
	$('#arQualityControl').css('display','none');
	$('#qualityLevels').sfList('clear');
	sf.service.setVolumeControl(false);
	
	sf.scene.hide('Player');
	sf.scene.show('Main');
	sf.scene.focus('Main');
			}
	sf.key.preventDefault();
}

ScenePlayer.prototype.handleKeyDown = function (keyCode) {
	alert("ScenePlayer.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	
	switch (keyCode) {
		case sf.key.LEFT:
			alert("LEFT"+sf.key.LEFT);		
			this.leftNavigation();
			break;
			
		case sf.key.RIGHT:
			alert("RIGHT"+sf.key.RIGHT);
			this.rightNavigation();
			break;
			
		case sf.key.UP:
			alert("UP"+sf.key.UP);
			if(this.changeQualityFlag){
				$('#qualityLevels').sfList('prev');
			}
			break;
			
		case sf.key.DOWN:
			alert("DOWN"+sf.key.DOWN);
			if(this.changeQualityFlag){
				$('#qualityLevels').sfList('next');
			}
			break;

		case sf.key.ENTER:
			alert("ENTER:"+sf.key.ENTER);
			this.enterNavigation();
			this.EndedFlag=false;
			this.updateKeyHelp();
			break;
			
		case sf.key.YELLOW:
			alert("YELLOW:"+sf.key.YELLOW);
			if(!this.EndedFlag){
			this.fullScreen();
			}
			break;
			
		case sf.key.GREEN:
			alert("GREEN:"+sf.key.GREEN);
			if(!this.EndedFlag){
			this.continuousPlay();
			}
			break;
			
		case sf.key.BLUE:
			alert("BLUE:"+sf.key.BLUE);

			if(EnglishFlag){ //in case u are in english state so change to arabic state
				EnglishFlag=false;
				this.updateKeyHelp();
				$('#enPlayerFrame').css('display','none');
				$('#arPlayerFrame').css('display','block');
				if(this.changeQualityFlag){
				$('#enQualityControl').css('display','none');
				$('#arQualityControl').css('display','block');
				}
			}
			else{ // u are in english state
				EnglishFlag=true;
				this.updateKeyHelp();
				$('#arPlayerFrame').css('display','none');
				$('#enPlayerFrame').css('display','block');
				if(this.changeQualityFlag){
				$('#arQualityControl').css('display','none');
				$('#enQualityControl').css('display','block');
				}
			}
			break;
		case sf.key.PLAY:
			alert("PLAY:"+sf.key.PLAY);
			this.PlayingFlag=true;
			this.PausedFlag=false;
			this.player.playVideo();
			this.EndedFlag=false;
			this.updateKeyHelp();
			break;
			
		case sf.key.PAUSE:
			alert("PAUSE:"+sf.key.PAUSE);
			this.PlayingFlag=false;
			this.PausedFlag=true;
			this.player.pauseVideo();
			break;
			
		case sf.key.STOP:
			alert("STOP:"+sf.key.STOP);
			break;
			
		case sf.key.RED:
			alert("RED:"+sf.key.RED);
			if(!this.EndedFlag){
			this.changeQuality();
			}
			break;
			
		case sf.key.N0:
			alert("N0:"+sf.key.N0);
			this.seeking(0);
			sf.key.preventDefault();
			break;
			
		case sf.key.N1:
			alert("N1:"+sf.key.N1);
			this.seeking(0.1);
			sf.key.preventDefault();
			break;
			
		case sf.key.N2:
			alert("N2:"+sf.key.N2);
			this.seeking(0.2);
			sf.key.preventDefault();
			break;
			
		case sf.key.N3:
			alert("N3:"+sf.key.N3);
			this.seeking(0.3);
			sf.key.preventDefault();
			break;
			
		case sf.key.N4:
			alert("N4:"+sf.key.N4);
			this.seeking(0.4);
			sf.key.preventDefault();
			break;
			
		case sf.key.N5:
			alert("N5:"+sf.key.N5);
			this.seeking(0.5);
			sf.key.preventDefault();
			break;
			
		case sf.key.N6:
			alert("N6:"+sf.key.N6);
			this.seeking(0.6);
			sf.key.preventDefault();
			break;
			
		case sf.key.N7:
			alert("N7:"+sf.key.N7);
			this.seeking(0.7);
			sf.key.preventDefault();
			break;
			
		case sf.key.N8:
			alert("N8:"+sf.key.N8);
			this.seeking(0.8);
			sf.key.preventDefault();
			break;
			
		case sf.key.N9:
			alert("N9:"+sf.key.N9);
			this.seeking(0.9);
			sf.key.preventDefault();
			break;
			
		case sf.key.RETURN:
			alert("RETURN:"+sf.key.RETURN);
			this.returnNavigation();
			sf.key.preventDefault();
			break;

	}
}