alert('SceneRedSea.js loaded');

function SceneRedSea() {
	this.LocationsArray=null; //Storing Locations ID, Names (ar,en), Position(top,left).
	this.ProvincesArray=null; //Storing Provinces Information.
	 this.HighlightIndex=0;
	 this.elementId=null;
	 this.previousElementId='RedSea-0';
	 this.elementIndex=0;
}

SceneRedSea.prototype.initialize = function () {
	alert("SceneRedSea.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called

	this.LocationsArray=[];
	this.ProvincesArray=[];
	var _THIS_=this;
	
	 	$.getJSON("json/RedSea.json",function(json){
	 		$.each(json,function(i,item){
	 			var lo_id=item.LocationId;
	 			var lo_en=item.LocationName_en;
	 			var lo_ar=item.LocationName_ar;
	 			var lo_top=item.Top;
	 			var lo_left=item.Left;
	 			var lo_width=item.width;
	 			var lo_lat=item.Lat;
	 			var lo_lng=item.Lng;
	 			
	 			var oLocations={}; //Creating Locations Object
	 			oLocations.id=lo_id;
	 			oLocations.en=lo_en;
	 			oLocations.ar=lo_ar;
	 			oLocations.top=lo_top;
	 			oLocations.left=lo_left;
	 			oLocations.width=lo_width;
	 			oLocations.lat=lo_lat;
	 			oLocations.lng=lo_lng;
	 			
	 			_THIS_.LocationsArray.push(oLocations);
	 									});
	 													});
	 	
	 	$.getJSON("json/RedSeaProvinces.json",function(json){
	 		$.each(json,function(i,item){
	 			var po_id=item.ProvinceId;
	 			var po_en=item.ProvinceName_en;
	 			var po_ar=item.ProvinceName_ar;
	 			var po_top=item.Top;
	 			var po_left=item.Left;
	 			var po_width=item.width;
	 			
	 			
			 
	 			var oProvinces={}; //Creating Locations Object
	 			oProvinces.id=po_id;
	 			oProvinces.en=po_en;
	 			oProvinces.ar=po_ar;
	 			oProvinces.top=po_top;
	 			oProvinces.left=po_left;
	 			oProvinces.width=po_width;
	 			
	 			_THIS_.ProvincesArray.push(oProvinces);
	 									});
	 													});
	 	
	 	var sceneRedSea=sf.scene.get('RedSea');
	 	//creating Div Elements of 10 locations.
	 	for (var i=0; i<10; i++){
			$('#RedSeaLocations').append("<div id='RedSea-"+i+"'></div>");
			
			//Handling MouseOver Events.
			$('#RedSea-'+i).mouseover(function(event){
				sceneRedSea.elementId = event.target.id;
				sceneRedSea.elementIndex = sceneRedSea.elementId.split('-');
				sceneRedSea.HighlightIndex = parseInt(sceneRedSea.elementIndex[1]);
				$('#'+sceneRedSea.previousElementId).css('color','#000000');
				$('#'+sceneRedSea.elementId).css('color','#3099fa')
			});
			//End of Handling
			//Handling Mouseout Events
			$('#RedSea-'+i).mouseout(function(event){
				sceneRedSea.previousElementId = event.target.id;
			});
		    //End of handling
			//Handling Click Event
			$('#RedSea-'+i).click(function(){

			//initialize
			$('#RedSeaTitle').text('');
			for (var i=0; i<sceneRedSea.LocationsArray.length; i++){
				$('#RedSea-'+i).text('');
			}
			for (var i=0; i<sceneRedSea.ProvincesArray.length; i++){
				$('#RedSeaProvince'+i).text('');
				}
			sf.scene.hide('RedSea');			
			sf.scene.show('Location');
			sf.scene.focus('Location');
			});
	 	}
	 	//Creating Div Elements of6 Provinces
	 	for (var i=0; i<6; i++){
			$('#RedSeaProvinces').append("<div id='RedSeaProvince"+i+"'></div>");
	 	}

}

SceneRedSea.prototype.handleShow = function (data) {
	alert("SceneRedSea.handleShow()");
	// this function will be called when the scene manager show this scene 
	var _th=this;
	//Showing Loading Icon
	$('#RedSeaMapLoading').sfLoading('show');
	
	//Scene Key Help
	if(EnglishFlag){
		$('#RedSeaKeyHelp').sfKeyHelp({
			'blue':'عربى',
			'move':'Navigate',
			'enter':'Enter',
			'return':'Return'
		});
	}
	else{
		$('#RedSeaKeyHelp').sfKeyHelp({
			'blue':'English',
			'move':'تحريك',
			'enter':'اختيار',
			'return':'رجوع'
		});
	}
	//End Key Help.
	
	
	setTimeout(function(){
		//Filling HTML ELEMENTS with Locations Name & their positions.
		for (var i=0; i<_th.LocationsArray.length; i++){
			
			if(EnglishFlag){
				$('#RedSea-'+i).text(_th.LocationsArray[i].en);
				$('#RedSeaTitle').text('Red Sea').removeClass('ArRedSea').addClass('En');
			}
			else{
				$('#RedSea-'+i).text(_th.LocationsArray[i].ar).removeClass('En').addClass('ArRedSea');
				$('#RedSeaTitle').text('البحر الاحمر')
				}
			$('#RedSea-'+i).css({	'position':'absolute',
			           				'top':_th.LocationsArray[i].top,
			           				'left':_th.LocationsArray[i].left,
			           				'width':_th.LocationsArray[i].width,
										});
			$('#RedSea-'+i).addClass('LocationsName');
														} //For END
		
		//Filling HTML Provinces ELEMENTS with  Names & their positions.
		for (var i=0; i<_th.ProvincesArray.length; i++){
			
			if(EnglishFlag){
				$('#RedSeaProvince'+i).text(_th.ProvincesArray[i].en).removeClass('ArRedSea').addClass('En');
				}
			else{
				$('#RedSeaProvince'+i).text(_th.ProvincesArray[i].ar).removeClass('En').addClass('ArRedSea');
				}
				$('#RedSeaProvince'+i).css({		'position':'absolute',
			           								'top':_th.ProvincesArray[i].top,
			           								'left':_th.ProvincesArray[i].left,
			           								'width':_th.ProvincesArray[i].width,
													});
				$('#RedSeaProvince'+i).addClass('ProvincesName');
														}//For END
		
				$('#RedSea-'+_th.HighlightIndex).css('color','#3099fa');
				$('#RedSeaMapLoading').sfLoading('hide');
	},100);

}

SceneRedSea.prototype.handleHide = function () {
	alert("SceneRedSea.handleHide()");
	// this function will be called when the scene manager hide this scene  
}

SceneRedSea.prototype.handleFocus = function () {
	alert("SceneRedSea.handleFocus()");
	// this function will be called when the scene manager focus this scene
}

SceneRedSea.prototype.handleBlur = function () {
	alert("SceneRedSea.handleBlur()");
	// this function will be called when the scene manager leftright focus to another scene from this scene
}

SceneRedSea.prototype.handleKeyDown = function (keyCode) {
	alert("SceneRedSea.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	
	switch (keyCode) {
		case sf.key.LEFT:
			alert("LEFT:"+sf.key.LEFT);
			if(this.HighlightIndex==9){
				$('#RedSea-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=0;
				$('#RedSea-'+this.HighlightIndex).css('color','#3099fa');
				 }
			else if(this.HighlightIndex==8){
				$('#RedSea-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=2;
				$('#RedSea-'+this.HighlightIndex).css('color','#3099fa');
				 }
			else if(this.HighlightIndex==7){
				$('#RedSea-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=3;
				$('#RedSea-'+this.HighlightIndex).css('color','#3099fa');
				 }
			else if(this.HighlightIndex==6){
				$('#RedSea-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=5;
				$('#RedSea-'+this.HighlightIndex).css('color','#3099fa');
				 }
			else if(this.HighlightIndex==5){
				$('#RedSea-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=4;
				$('#RedSea-'+this.HighlightIndex).css('color','#3099fa');
				 }
			this.previousElementId='RedSea-'+this.HighlightIndex;
			break;
				
		
		case sf.key.RIGHT:
			alert("RIGHT:"+sf.key.RIGHT);
			
			if(this.HighlightIndex==0){
				$('#RedSea-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=9;
				$('#RedSea-'+this.HighlightIndex).css('color','#3099fa');
				 }
			else if(this.HighlightIndex==2){
				$('#RedSea-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=8;
				$('#RedSea-'+this.HighlightIndex).css('color','#3099fa');
				 }
			else if(this.HighlightIndex==3){
				$('#RedSea-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=7;
				$('#RedSea-'+this.HighlightIndex).css('color','#3099fa');
				 }
			else if(this.HighlightIndex==5){
				$('#RedSea-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=6;
				$('#RedSea-'+this.HighlightIndex).css('color','#3099fa');
				 }
			this.previousElementId='RedSea-'+this.HighlightIndex;
			break;
			
		case sf.key.DOWN:
			
			if(this.HighlightIndex==10){
				$('#RedSea-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=5;
				$('#RedSea-'+this.HighlightIndex).css('color','#3099fa');
				 }
			else if(this.HighlightIndex>=0 && this.HighlightIndex<6 ){
				$('#RedSea-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex+=1;
				$('#RedSea-'+this.HighlightIndex).css('color','#3099fa');
				 }
			else if(this.HighlightIndex<10 && this.HighlightIndex>=7 ){
				$('#RedSea-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex-=1;
				$('#RedSea-'+this.HighlightIndex).css('color','#3099fa');
				 }
			this.previousElementId='RedSea-'+this.HighlightIndex;
					break;
		case sf.key.UP:
			if(this.HighlightIndex==6){
				$('#RedSea-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=7;
				$('#RedSea-'+this.HighlightIndex).css('color','#3099fa');
				}
			else if(this.HighlightIndex>0 && this.HighlightIndex<6 ){
				$('#RedSea-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex-=1;
				$('#RedSea-'+this.HighlightIndex).css('color','#3099fa');
				}
			else if(this.HighlightIndex<9 && this.HighlightIndex>=7 ){
				$('#RedSea-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex+=1;
				$('#RedSea-'+this.HighlightIndex).css('color','#3099fa');
				}
			this.previousElementId='RedSea-'+this.HighlightIndex;
					break;
					
		case sf.key.ENTER:
			alert("ENTER:"+sf.key.ENTER);

			//initialize
			$('#RedSeaTitle').text('');
			for (var i=0; i<this.LocationsArray.length; i++){
				$('#RedSeaDesert'+i).text('');
			}
			for (var i=0; i<this.ProvincesArray.length; i++){
				$('#RedSeaProvince'+i).text('');
				}
			sf.scene.hide('RedSea');			
			sf.scene.show('Location');
			sf.scene.focus('Location');
			break;
			
		case sf.key.BLUE:
			alert("BLUE:"+sf.key.BLUE);
			if(EnglishFlag){
				EnglishFlag=false;
				$('#RedSeaKeyHelp').sfKeyHelp({
					'blue':'English',
					'move':'تحريك',
					'enter':'اختيار',
					'return':'رجوع'
				});
				$('#RedSeaTitle').text('البحر الاحمر');
			for (var i=0; i<this.LocationsArray.length; i++){
				$('#RedSea-'+i).text(this.LocationsArray[i].ar);
				$('#RedSea-'+i).removeClass('En').addClass('ArRedSea');}
			for (var i=0; i<this.ProvincesArray.length; i++){
				$('#RedSeaProvince'+i).text(this.ProvincesArray[i].ar);
				$('#RedSeaProvince'+i).removeClass('En').addClass('ArRedSea');}

									}
			else{
				EnglishFlag=true;
				$('#RedSeaKeyHelp').sfKeyHelp({
					'blue':'عربى',
					'move':'Navigate',
					'enter':'Enter',
					'return':'Return'
				});
				$('#RedSeaTitle').text('Red Sea');
				for (var i=0; i<this.LocationsArray.length; i++){
					$('#RedSea-'+i).text(this.LocationsArray[i].en);
					$('#RedSea-'+i).removeClass('ArRedSea').addClass('En');}
				for (var i=0; i<this.ProvincesArray.length; i++){
					$('#RedSeaProvince'+i).text(this.ProvincesArray[i].en);
					$('#RedSeaProvince'+i).removeClass('ArRedSea').addClass('En');}
			
			}
			break;
		case sf.key.RETURN:
			alert("RETURN:"+sf.key.RETURN);
			//intialize
			$('#RedSeaTitle').text('');
			for (var i=0; i<this.LocationsArray.length; i++){
				$('#RedSeaDesert'+i).text('');
			}
			for (var i=0; i<this.ProvincesArray.length; i++){
				$('#RedSeaProvince'+i).text('');
				}
			sf.scene.hide('RedSea');
			sf.scene.show('Maps');
			sf.scene.focus('Maps');
			sf.key.preventDefault();
		
			break;
	}
}