alert('SceneWesternDesert.js loaded');

function SceneWesternDesert() {
	this.LocationsArray=null; //Storing Locations ID, Names (ar,en), Position(top,left).
	this.ProvincesArray=null; //Storing Provinces Information.
	 this.HighlightIndex=0;
	 this.elementId=null;
	 this.previousElementId='WesternDesert-0';
	 this.elementIndex=0;
}

SceneWesternDesert.prototype.initialize = function () {
	alert("SceneWesternDesert.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called

	this.LocationsArray=[];
	this.ProvincesArray=[];
	var _THIS_=this;
	
	 	$.getJSON("json/WesternDesert.json",function(json){
	 		$.each(json,function(i,item){
	 			var lo_id=item.LocationId;
	 			var lo_en=item.LocationName_en;
	 			var lo_ar=item.LocationName_ar;
	 			var lo_top=item.Top;
	 			var lo_left=item.Left;
	 			var lo_width=item.width;
	 			var lo_lat=item.Lat;
	 			var lo_lng=item.Lng;
	 			
	 			var oLocations={}; //Creating Locations Object
	 			oLocations.id=lo_id;
	 			oLocations.en=lo_en;
	 			oLocations.ar=lo_ar;
	 			oLocations.top=lo_top;
	 			oLocations.left=lo_left;
	 			oLocations.width=lo_width;
	 			oLocations.lat=lo_lat;
	 			oLocations.lng=lo_lng;
	 			
	 			_THIS_.LocationsArray.push(oLocations);
	 									});
	 													});
	 	
	 	$.getJSON("json/WesternDesertProvinces.json",function(json){
	 		$.each(json,function(i,item){
	 			var po_id=item.ProvinceId;
	 			var po_en=item.ProvinceName_en;
	 			var po_ar=item.ProvinceName_ar;
	 			var po_top=item.Top;
	 			var po_left=item.Left;
	 			
			 
	 			var oProvinces={}; //Creating Locations Object
	 			oProvinces.id=po_id;
	 			oProvinces.en=po_en;
	 			oProvinces.ar=po_ar;
	 			oProvinces.top=po_top;
	 			oProvinces.left=po_left;
	 			//oProvinces.width=po_width;
	 			
	 			_THIS_.ProvincesArray.push(oProvinces);
	 									});
	 													});
	 	
		var sceneWesternDesert=sf.scene.get('WesternDesert');

	 	//creating Div Elements of 9 locations.
	 	for (var i=0; i<9; i++){
			$('#WesternDesertLocations').append("<div id='WesternDesert-"+i+"'></div>");
			//Handling MouseOver Events.
			$('#WesternDesert-'+i).mouseover(function(event){
				sceneWesternDesert.elementId = event.target.id;
				sceneWesternDesert.elementIndex = sceneWesternDesert.elementId.split('-');
				sceneWesternDesert.HighlightIndex = parseInt(sceneWesternDesert.elementIndex[1]);
				$('#'+sceneWesternDesert.previousElementId).css('color','#000000');
				$('#'+sceneWesternDesert.elementId).css('color','#3099fa')
			});
			//End of Handling
			//Handling Mouseout Events
			$('#WesternDesert-'+i).mouseout(function(event){
				sceneWesternDesert.previousElementId = event.target.id;
			});
		    //End of handling
			//Handling Click Event
			$('#WesternDesert-'+i).click(function(){

			//initialize
			$('#WesternDesertTitle').text('');
			for (var i=0; i<sceneWesternDesert.LocationsArray.length; i++){
				$('#WesternDesert-'+i).text('');
			}
			for (var i=0; i<sceneWesternDesert.ProvincesArray.length; i++){
				$('#WesternDesertProvince'+i).text('');
				}
			sf.scene.hide('WesternDesert');			
			sf.scene.show('Location');
			sf.scene.focus('Location');

			});
	 	}
	 	//Creating Div Elements of1 Provinces
	 	for (var i=0; i<1; i++){
			$('#WesternDesertProvinces').append("<div id='WesternDesertProvince"+i+"'></div>");
	 	}

}

SceneWesternDesert.prototype.handleShow = function (data) {
	alert("SceneWesternDesert.handleShow()");
	// this function will be called when the scene manager show this scene 
	var _th=this;
	//Showing Loading Icon
	$('#WesternDesertMapLoading').sfLoading('show');
	
	//Scene Key Help
	if(EnglishFlag){
		$('#WesternDesertKeyHelp').sfKeyHelp({
			'blue':'عربى',
			'move':'Navigate',
			'enter':'Enter',
			'return':'Return'
		});
	}
	else{
		$('#WesternDesertKeyHelp').sfKeyHelp({
			'blue':'English',
			'move':'تحريك',
			'enter':'اختيار',
			'return':'رجوع'
		});
	}
	//End Key Help.
	
	
	
	setTimeout(function(){
		//Filling HTML ELEMENTS with Locations Name & their positions.
		for (var i=0; i<_th.LocationsArray.length; i++){
			
			if(EnglishFlag){
				$('#WesternDesert-'+i).text(_th.LocationsArray[i].en).removeClass('ArWesternDesert').addClass('En');
				$('#WesternDesertTitle').text('Western Desert');	
							}
			else{
				$('#WesternDesert-'+i).text(_th.LocationsArray[i].ar).removeClass('En').addClass('ArWesternDesert');
				$('#WesternDesertTitle').text('الصحراء الغربية');
				}
			
			$('#WesternDesert-'+i).css({	'position':'absolute',
			           						'top':_th.LocationsArray[i].top,
			           						'left':_th.LocationsArray[i].left,
			           						'width':_th.LocationsArray[i].width,
										});
			$('#WesternDesert-'+i).addClass('LocationsName');
														} //For END
		
		//Filling HTML Provinces ELEMENTS with  Names & their positions.
		for (var i=0; i<_th.ProvincesArray.length; i++){
			
			if(EnglishFlag){
				$('#WesternDesertProvince'+i).text(_th.ProvincesArray[i].en).removeClass('ArWesternDesert').addClass('En');
				}
			else{
				$('#WesternDesertProvince'+i).text(_th.ProvincesArray[i].ar).removeClass('En').addClass('ArWesternDesert');
				}
			
			$('#WesternDesertProvince'+i).css({	'position':'absolute',
			           							'top':_th.ProvincesArray[i].top,
			           							'left':_th.ProvincesArray[i].left,
			           							});
			$('#WesternDesertProvince'+i).addClass('ProvincesName');
														}//For END
		
			$('#WesternDesert-'+_th.HighlightIndex).css('color','#3099fa');//}//ELSE END
			$('#WesternDesertMapLoading').sfLoading('hide');
	},100);

}

SceneWesternDesert.prototype.handleHide = function () {
	alert("SceneWesternDesert.handleHide()");
	// this function will be called when the scene manager hide this scene  
}

SceneWesternDesert.prototype.handleFocus = function () {
	alert("SceneWesternDesert.handleFocus()");
	// this function will be called when the scene manager focus this scene
}

SceneWesternDesert.prototype.handleBlur = function () {
	alert("SceneWesternDesert.handleBlur()");
	// this function will be called when the scene manager leftright focus to another scene from this scene
}

SceneWesternDesert.prototype.handleKeyDown = function (keyCode) {
	alert("SceneWesternDesert.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	
	switch (keyCode) {
		case sf.key.LEFT:
			alert("LEFT:"+sf.key.LEFT);
			if(this.HighlightIndex==8){
				$('#WesternDesert-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=0;
				$('#WesternDesert-'+this.HighlightIndex).css('color','#3099fa');
			}
			else if(this.HighlightIndex==7){
				$('#WesternDesert-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=8;
				$('#WesternDesert-'+this.HighlightIndex).css('color','#3099fa');
			}
			else if(this.HighlightIndex==6){
				$('#WesternDesert-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=1;
				$('#WesternDesert-'+this.HighlightIndex).css('color','#3099fa');
			}
			else if(this.HighlightIndex==5){
				$('#WesternDesert-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=2;
				$('#WesternDesert-'+this.HighlightIndex).css('color','#3099fa');
			}
			else if(this.HighlightIndex==4){
				$('#WesternDesert-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=3;
				$('#WesternDesert-'+this.HighlightIndex).css('color','#3099fa');
			}
			this.previousElementId='WesternDesert-'+this.HighlightIndex;
			break;	
		case sf.key.RIGHT:
			alert("RIGHT:"+sf.key.RIGHT);
			if(this.HighlightIndex==0){
				$('#WesternDesert-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=8;
				$('#WesternDesert-'+this.HighlightIndex).css('color','#3099fa');
			}
			else if(this.HighlightIndex==8){
				$('#WesternDesert-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=7;
				$('#WesternDesert-'+this.HighlightIndex).css('color','#3099fa');
			}
			else if(this.HighlightIndex==1){
				$('#WesternDesert-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=6;
				$('#WesternDesert-'+this.HighlightIndex).css('color','#3099fa');
			}
			else if(this.HighlightIndex==2){
				$('#WesternDesert-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=5;
				$('#WesternDesert-'+this.HighlightIndex).css('color','#3099fa');
			}
			else if(this.HighlightIndex==3){
				$('#WesternDesert-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex=4;
				$('#WesternDesert-'+this.HighlightIndex).css('color','#3099fa');
			}
			this.previousElementId='WesternDesert-'+this.HighlightIndex;
			break;
		case sf.key.UP:
			alert("UP:"+sf.key.UP);
			if(this.HighlightIndex>0&&this.HighlightIndex<=3){
				$('#WesternDesert-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex--;
				$('#WesternDesert-'+this.HighlightIndex).css('color','#3099fa');
			}
			else if(this.HighlightIndex<7&&this.HighlightIndex>=4){
				$('#WesternDesert-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex++;
				$('#WesternDesert-'+this.HighlightIndex).css('color','#3099fa');
			}
			this.previousElementId='WesternDesert-'+this.HighlightIndex;
			break;
		case sf.key.DOWN:
			alert("DOWN:"+sf.key.DOWN);
			if(this.HighlightIndex>=0&&this.HighlightIndex<3){
				$('#WesternDesert-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex++;
				$('#WesternDesert-'+this.HighlightIndex).css('color','#3099fa');
			}
			else if(this.HighlightIndex<=7&&this.HighlightIndex>4){
				$('#WesternDesert-'+this.HighlightIndex).css('color','#000000');
				this.HighlightIndex--;
				$('#WesternDesert-'+this.HighlightIndex).css('color','#3099fa');
			}
			this.previousElementId='WesternDesert-'+this.HighlightIndex;
			break;
		case sf.key.ENTER:
			alert("ENTER:"+sf.key.ENTER);

			//initialize
			$('#WesternDesertTitle').text('');
			for (var i=0; i<this.LocationsArray.length; i++){
				$('#WesternDesert-'+i).text('');
			}
			for (var i=0; i<this.ProvincesArray.length; i++){
				$('#WesternDesertProvince'+i).text('');
				}
			sf.scene.hide('WesternDesert');			
			sf.scene.show('Location');
			sf.scene.focus('Location');
			break;
			
		case sf.key.BLUE:
			alert("BLUE:"+sf.key.BLUE);
			if(EnglishFlag){
				EnglishFlag=false;
				$('#WesternDesertKeyHelp').sfKeyHelp({
					'blue':'English',
					'move':'تحريك',
					'enter':'اختيار',
					'return':'رجوع'
				});
				$('#WesternDesertTitle').text('الصحراء الغربية');
			for (var i=0; i<this.LocationsArray.length; i++){
				$('#WesternDesert-'+i).text(this.LocationsArray[i].ar);
				$('#WesternDesert-'+i).removeClass('En').addClass('ArWesternDesert');}
			for (var i=0; i<this.ProvincesArray.length; i++){
				$('#WesternDesertProvince'+i).text(this.ProvincesArray[i].ar);
				$('#WesternDesertProvince'+i).removeClass('En').addClass('ArWesternDesert');}

									}
			else{
				EnglishFlag=true;
				$('#WesternDesertKeyHelp').sfKeyHelp({
					'blue':'عربى',
					'move':'Navigate',
					'enter':'Enter',
					'return':'Return'
				});
				$('#WesternDesertTitle').text('Western Desert');
				for (var i=0; i<this.LocationsArray.length; i++){
					$('#WesternDesert-'+i).text(this.LocationsArray[i].en);
					$('#WesternDesert-'+i).removeClass('ArWesternDesert').addClass('En');}
				for (var i=0; i<this.ProvincesArray.length; i++){
					$('#WesternDesertProvince'+i).text(this.ProvincesArray[i].en);
					$('#WesternDesertProvince'+i).removeClass('ArWesternDesert').addClass('En');}
			
			}
			break;
		
		case sf.key.RETURN:
			alert("RETURN:"+sf.key.RETURN);
			//intialize
			$('#WesternDesertTitle').text('');
			for (var i=0; i<this.LocationsArray.length; i++){
				$('#WesternDesert-'+i).text('');
			}
			for (var i=0; i<this.ProvincesArray.length; i++){
				$('#WesternDesertProvince'+i).text('');
				}
			sf.scene.hide('WesternDesert');
			sf.scene.show('Maps');
			sf.scene.focus('Maps');
			sf.key.preventDefault();
		
			break;
	}
}